#coding=utf-8

P_TYPE = {'http': 'http://', 'https': 'https://'}
FLYSHARE_URL='%s%s/trading/%s?code=%s&start=%s&end=%s'

DATA_SOURCE = 'http://www.flyshare.ml:8000'

K_LABELS = ['D', 'W', 'M']
K_MIN_LABELS = ['5', '15', '30', '60']
K_TYPE = {'D': 'akdaily', 'W': 'akweekly', 'M': 'akmonthly'}
TT_K_TYPE = {'D': 'day', 'W': 'week', 'M': 'month'}
FQ_KEY = ['qfqday', 'hfqday', 'day']
INDEX_LABELS = ['sh', 'sz', 'hs300', 'sz50', 'cyb', 'zxb', 'zx300', 'zh500']
INDEX_LIST = {'sh': 'sh000001', 'sz': 'sz399001', 'hs300': 'sh000300',
              'sz50': 'sh000016', 'zxb': 'sz399005', 'cyb': 'sz399006',
              'zx300': 'sz399008', 'zh500': 'sh000905'}
PAGE_NUM = [40, 60, 80, 100]
FORMAT = lambda x: '%.2f' % x
FORMAT4 = lambda x: '%.4f' % x
DOMAINS = {'sina': 'sina.com.cn', 'sinahq': 'sinajs.cn',
           'ifeng': 'ifeng.com', 'sf': 'finance.sina.com.cn',
           'vsf': 'vip.stock.finance.sina.com.cn',
           'idx': 'www.csindex.com.cn', '163': 'money.163.com',
           'em': 'eastmoney.com', 'sseq': 'query.sse.com.cn',
           'sse': 'www.sse.com.cn', 'szse': 'www.szse.cn',
           'oss': 'file.tushare.org', 'idxip': '115.29.204.48',
           'shibor': 'www.shibor.org', 'mbox': 'www.cbooo.cn',
           'tt': 'gtimg.cn', 'gw': 'gw.com.cn',
           'v500': 'value500.com', 'flyshare': 'www.flyshare.ml:8000'}
PAGES = {'fd': 'index.phtml', 'dl': 'downxls.php', 'jv': 'json_v2.php',
         'cpt': 'newFLJK.php', 'ids': 'newSinaHy.php', 'lnews': 'rollnews_ch_out_interface.php',
         'ntinfo': 'vCB_BulletinGather.php', 'hs300b': '000300cons.xls',
         'hs300w': '000300closeweight.xls', 'sz50b': '000016cons.xls',
         'dp': 'all_fpya.php', '163dp': 'fpyg.html',
         'emxsg': 'JS.aspx', '163fh': 'jjcgph.php',
         'newstock': 'vRPD_NewStockIssue.php', 'zz500b': '000905cons.xls',
         'zz500wt': '000905closeweight.xls',
         't_ticks': 'vMS_tradedetail.php', 'dw': 'downLoad.html',
         'qmd': 'queryMargin.do', 'szsefc': 'ShowReport.szse',
         'ssecq': 'commonQuery.do', 'sinadd': 'cn_bill_download.php', 'ids_sw': 'SwHy.php',
         'idx': 'index.php','histdata':'histdata'}
TICK_COLUMNS = ['time', 'price', 'change', 'volume', 'amount', 'type']
TODAY_TICK_COLUMNS = ['time', 'price', 'pchange', 'change', 'volume', 'amount', 'type']
DAY_TRADING_COLUMNS = ['code', 'symbol', 'name', 'changepercent',
                       'trade', 'open', 'high', 'low', 'settlement', 'volume', 'turnoverratio',
                       'amount', 'per', 'pb', 'mktcap', 'nmc']
REPORT_COLS = ['code', 'name', 'eps', 'eps_yoy', 'bvps', 'roe',
               'epcf', 'net_profits', 'profits_yoy', 'distrib', 'report_date']
FORECAST_COLS = ['code', 'name', 'type', 'report_date', 'pre_eps', 'range']
PROFIT_COLS = ['code', 'name', 'roe', 'net_profit_ratio',
               'gross_profit_rate', 'net_profits', 'eps', 'business_income', 'bips']
OPERATION_COLS = ['code', 'name', 'arturnover', 'arturndays', 'inventory_turnover',
                  'inventory_days', 'currentasset_turnover', 'currentasset_days']
GROWTH_COLS = ['code', 'name', 'mbrg', 'nprg', 'nav', 'targ', 'epsg', 'seg']
DEBTPAYING_COLS = ['code', 'name', 'currentratio',
                   'quickratio', 'cashratio', 'icratio', 'sheqratio', 'adratio']
CASHFLOW_COLS = ['code', 'name', 'cf_sales', 'rateofreturn',
                 'cf_nm', 'cf_liabilities', 'cashflowratio']
DAY_PRICE_COLUMNS = ['date', 'open', 'high', 'close', 'low', 'volume', 'price_change', 'p_change',
                     'ma5', 'ma10', 'ma20', 'v_ma5', 'v_ma10', 'v_ma20', 'turnover']
INX_DAY_PRICE_COLUMNS = ['date', 'open', 'high', 'close', 'low', 'volume', 'price_change', 'p_change',
                         'ma5', 'ma10', 'ma20', 'v_ma5', 'v_ma10', 'v_ma20']
LIVE_DATA_COLS = ['name', 'open', 'pre_close', 'price', 'high', 'low', 'bid', 'ask', 'volume', 'amount',
                  'b1_v', 'b1_p', 'b2_v', 'b2_p', 'b3_v', 'b3_p', 'b4_v', 'b4_p', 'b5_v', 'b5_p',
                  'a1_v', 'a1_p', 'a2_v', 'a2_p', 'a3_v', 'a3_p', 'a4_v', 'a4_p', 'a5_v', 'a5_p', 'date', 'time', 's']
FOR_CLASSIFY_B_COLS = ['code', 'name']
FOR_CLASSIFY_W_COLS = ['date', 'code', 'weight']
FOR_CLASSIFY_W5_COLS = ['date', 'code', 'name', 'weight']
THE_FIELDS = ['code', 'symbol', 'name', 'changepercent', 'trade', 'open', 'high', 'low', 'settlement', 'volume',
              'turnoverratio']
KLINE_TT_COLS_MINS = ['date', 'open', 'close', 'high', 'low', 'volume']
KLINE_TT_COLS = ['date', 'open', 'close', 'high', 'low', 'volume', 'amount', 'turnoverratio']
TICK_PRICE_URL = '%smarket.%s/%s?date=%s&symbol=%s'
TICK_PRICE_URL_TT = '%sstock.%s/data/%s?appn=detail&action=download&c=%s&d=%s'
TICK_PRICE_URL_NT = '%squotes.%s/cjmx/%s/%s/%s.xls'
TODAY_TICKS_PAGE_URL = '%s%s/quotes_service/api/%s/CN_Transactions.getAllPageTime?date=%s&symbol=%s'
TODAY_TICKS_URL = '%s%s/quotes_service/view/%s?symbol=%s&date=%s&page=%s'
KLINE_TT_URL = '%sweb.ifzq.%s/appstock/app/%skline/get?_var=kline_day%s&param=%s,%s,%s,%s,640,%s&r=0.%s'
KLINE_TT_MIN_URL = '%sifzq.%s/appstock/app/kline/mkline?param=%s,m%s,,640&_var=m%s_today&r=0.%s'
DAY_PRICE_URL = '%sapi.finance.%s/%s/?code=%s&type=last'
LIVE_DATA_URL = '%shq.%s/rn=%s&list=%s'
DAY_PRICE_MIN_URL = '%sapi.finance.%s/akmin?scode=%s&type=%s'
SINA_DAY_PRICE_URL = '%s%s/quotes_service/api/%s/Market_Center.getHQNodeData?num=80&sort=code&asc=0&node=%s&symbol=&_s_r_a=page&page=%s'
# SINA_DAY_PRICE_URL = '%s%s/quotes_service/api/%s/Market_Center.getHQNodeData?num=10000&node=%s'
REPORT_URL = '%s%s/q/go.php/vFinanceAnalyze/kind/mainindex/%s?s_i=&s_a=&s_c=&reportdate=%s&quarter=%s&p=%s&num=%s'
FORECAST_URL = '%s%s/q/go.php/vFinanceAnalyze/kind/performance/%s?s_i=&s_a=&s_c=&s_type=&reportdate=%s&quarter=%s&p=%s&num=%s'
PROFIT_URL = '%s%s/q/go.php/vFinanceAnalyze/kind/profit/%s?s_i=&s_a=&s_c=&reportdate=%s&quarter=%s&p=%s&num=%s'
OPERATION_URL = '%s%s/q/go.php/vFinanceAnalyze/kind/operation/%s?s_i=&s_a=&s_c=&reportdate=%s&quarter=%s&p=%s&num=%s'
GROWTH_URL = '%s%s/q/go.php/vFinanceAnalyze/kind/grow/%s?s_i=&s_a=&s_c=&reportdate=%s&quarter=%s&p=%s&num=%s'
DEBTPAYING_URL = '%s%s/q/go.php/vFinanceAnalyze/kind/debtpaying/%s?s_i=&s_a=&s_c=&reportdate=%s&quarter=%s&p=%s&num=%s'
CASHFLOW_URL = '%s%s/q/go.php/vFinanceAnalyze/kind/cashflow/%s?s_i=&s_a=&s_c=&reportdate=%s&quarter=%s&p=%s&num=%s'
SHIBOR_TYPE = {'Shibor': 'Shibor数据', 'Quote': '报价数据', 'Tendency': 'Shibor均值数据',
               'LPR': 'LPR数据', 'LPR_Tendency': 'LPR均值数据'}
SHIBOR_DATA_URL = '%s%s/shibor/web/html/%s?nameNew=Historical_%s_Data_%s.xls&downLoadPath=data&nameOld=%s%s.xls&shiborSrc=http://www.shibor.org/shibor/'
ALL_STOCK_BASICS_FILE = P_TYPE['http'] + DOMAINS['oss'] + '/tsdata/%sall%s.csv'
ALL_DAY_FILE = P_TYPE['http'] + DOMAINS['oss'] + '/tsdata/h/%s%s.csv'
ALL_CAL_FILE = '%s%s/tsdata/calAll.csv' % (P_TYPE['http'], DOMAINS['oss'])
SINA_CONCEPTS_INDEX_URL = '%smoney.%s/q/view/%s?param=class'
SINA_INDUSTRY_INDEX_URL = '%s%s/q/view/%s'
SINA_DATA_DETAIL_URL = '%s%s/quotes_service/api/%s/Market_Center.getHQNodeData?page=%s&num=1000&sort=symbol&asc=1&node=%s&symbol=&_s_r_a=page'
SINA_BALANCESHEET_URL = 'http://money.finance.sina.com.cn/corp/go.php/vDOWN_BalanceSheet/displaytype/4/stockid/%s/ctrl/all.phtml'
SINA_PROFITSTATEMENT_URL = 'http://money.finance.sina.com.cn/corp/go.php/vDOWN_ProfitStatement/displaytype/4/stockid/%s/ctrl/all.phtml'
SINA_CASHFLOW_URL = 'http://money.finance.sina.com.cn/corp/go.php/vDOWN_CashFlow/displaytype/4/stockid/%s/ctrl/all.phtml'
INDEX_C_COMM = 'sseportal/ps/zhs/hqjt/csi'
HS300_CLASSIFY_URL_FTP = '%s%s/webdata/%s'
HS300_CLASSIFY_URL_HTTP = '%s%s/%s/%s'
BDI_URL = '%s%s/BDI.asp'
HIST_FQ_URL = '%s%s/corp/go.php/vMS_FuQuanMarketHistory/stockid/%s.phtml?year=%s&jidu=%s'
HIST_INDEX_URL = '%s%s/corp/go.php/vMS_MarketHistory/stockid/%s/type/S.phtml?year=%s&jidu=%s'
HIST_FQ_FACTOR_URL = '%s%s/api/json.php/BasicStockSrv.getStockFuQuanData?symbol=%s&type=hfq'
INDEX_HQ_URL = '''%shq.%s/rn=xppzh&list=sh000001,sh000002,sh000003,sh000008,sh000009,sh000010,sh000011,sh000012,sh000016,sh000017,sh000300,sh000905,sz399001,sz399002,sz399003,sz399004,sz399005,sz399006,sz399008,sz399100,sz399101,sz399106,sz399107,sz399108,sz399333,sz399606'''
SSEQ_CQ_REF_URL = '%s%s/assortment/stock/list/name'
ALL_STK_URL = '%s%s/all.csv'
SINA_DD = '%s%s/quotes_service/view/%s?symbol=%s&num=60&page=1&sort=ticktime&asc=0&volume=%s&amount=0&type=0&day=%s'
BOX = 'boxOffice'
MOVIE_BOX = '%s%s/%s/GetHourBoxOffice?d=%s'
BOXOFFICE_DAY = '%s%s/%s/GetDayBoxOffice?num=%s&d=%s'
BOXOFFICE_MONTH = '%s%s/%s/getMonthBox?sdate=%s'
BOXOFFICE_CBD = '%s%s/%s/getCBD?pIndex=%s&dt=%s'
SHIBOR_COLS = ['date', 'ON', '1W', '2W', '1M', '3M', '6M', '9M', '1Y']
QUOTE_COLS = ['date', 'bank', 'ON_B', 'ON_A', '1W_B', '1W_A', '2W_B', '2W_A', '1M_B', '1M_A',
              '3M_B', '3M_A', '6M_B', '6M_A', '9M_B', '9M_A', '1Y_B', '1Y_A']
SHIBOR_MA_COLS = ['date', 'ON_5', 'ON_10', 'ON_20', '1W_5', '1W_10', '1W_20', '2W_5', '2W_10', '2W_20',
                  '1M_5', '1M_10', '1M_20', '3M_5', '3M_10', '3M_20', '6M_5', '6M_10', '6M_20',
                  '9M_5', '9M_10', '9M_20', '1Y_5', '1Y_10', '1Y_20']
LPR_COLS = ['date', '1Y']
LPR_MA_COLS = ['date', '1Y_5', '1Y_10', '1Y_20']
INDEX_HEADER = 'code,name,open,preclose,close,high,low,0,0,volume,amount,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,d,c,3\n'
INDEX_COLS = ['code', 'name', 'change', 'open', 'preclose', 'close', 'high', 'low', 'volume', 'amount']
HIST_FQ_COLS = ['date', 'open', 'high', 'close', 'low', 'volume', 'amount', 'factor']
SINA_DD_COLS = ['code', 'name', 'time', 'price', 'volume', 'preprice', 'type']
GLOBAL_HQ_SYMBOL = 'sh000001,hkHSI,znb_UKX,znb_DAX,znb_INDEXCF,znb_CAC,znb_SMI,znb_FTSEMIB,znb_MADX,znb_OMX,znb_SPX,znb_HEX,znb_OSEAX,znb_ISEQ,znb_AEX,znb_ICEXI,znb_NKY,znb_TWSE,znb_FSSTI,znb_KOSPI,znb_FBMKLCI,znb_SET,znb_JCI,znb_PCOMP,znb_KSE100,znb_SENSEX,znb_VNINDEX,znb_CSEALL,znb_SASEIDX,znb_SPTSX,znb_MEXBOL,znb_IBOV,znb_MERVAL,znb_AS51,znb_NZSE50FG,znb_CASE,znb_JALSH,sz399001,znb_INDU,znb_CCMP'
GLOBAL_HQ_COLS = ['symbol', 'name', 'price', 'chga', 'chgp', 'datetime']
PROFIT_DIVIS = ['code',
                'name',
                'year',
                'bshares',
                'incshares',
                'totals',
                'cash',
                'plandate',
                'regdate',
                'exdate',
                'eventproc',
                'anndate']
HIST_FQ_FACTOR_COLS = ['code', 'value']
DATA_GETTING_TIPS = '[Getting data:]'
DATA_GETTING_FLAG = '#'
DATA_ROWS_TIPS = '%s rows data found.Please wait for a moment.'
DATA_INPUT_ERROR_MSG = 'date input error.'
NETWORK_URL_ERROR_MSG = '获取失败，请检查网络和URL'
DATE_CHK_MSG = '年度输入错误：请输入1989年以后的年份数字，格式：YYYY'
DATE_CHK_Q_MSG = '季度输入错误：请输入1、2、3或4数字'
TOP_PARAS_MSG = 'top有误，请输入整数或all.'
LHB_MSG = '周期输入有误，请输入数字5、10、30或60'
TOKEN_F_P = 'tk.csv'
TOKEN_ERR_MSG = '请设置通联数据接口的token凭证码'
BOX_INPUT_ERR_MSG = '请输入YYYY-MM格式的年月数据'
TICK_SRCS = ['sn', 'tt', 'nt']
TICK_SRC_ERROR = '数据源代码只能输入sn,tt,nt其中之一'
INDEX_SYMBOL = {"399990": "sz399990", "000006": "sh000006", "399998": "sz399998",
                "399436": "sz399436", "399678": "sz399678", "399804": "sz399804",
                "000104": "sh000104", "000070": "sh000070", "399613": "sz399613",
                "399690": "sz399690", "399928": "sz399928", "000928": "sh000928",
                "000986": "sh000986", "399806": "sz399806", "000032": "sh000032",
                "000005": "sh000005", "399381": "sz399381", "399908": "sz399908",
                "000908": "sh000908", "399691": "sz399691", "000139": "sh000139",
                "399427": "sz399427", "399248": "sz399248", "000832": "sh000832",
                "399901": "sz399901", "399413": "sz399413", "000901": "sh000901",
                "000078": "sh000078", "000944": "sh000944", "000025": "sh000025",
                "399944": "sz399944", "399307": "sz399307", "000052": "sh000052",
                "399680": "sz399680", "399232": "sz399232", "399993": "sz399993",
                "000102": "sh000102", "000950": "sh000950", "399950": "sz399950",
                "399244": "sz399244", "399925": "sz399925", "000925": "sh000925",
                "000003": "sh000003", "000805": "sh000805", "000133": "sh000133",
                "399677": "sz399677", "399319": "sz399319", "399397": "sz399397",
                "399983": "sz399983", "399654": "sz399654", "399440": "sz399440",
                "000043": "sh000043", "000012": "sh000012", "000833": "sh000833",
                "000145": "sh000145", "000053": "sh000053", "000013": "sh000013",
                "000022": "sh000022", "000094": "sh000094", "399299": "sz399299",
                "000101": "sh000101", "399817": "sz399817", "399481": "sz399481",
                "399434": "sz399434", "399301": "sz399301", "000029": "sh000029",
                "399812": "sz399812", "399441": "sz399441", "000098": "sh000098",
                "399557": "sz399557", "000068": "sh000068", "399298": "sz399298",
                "399302": "sz399302", "000961": "sh000961", "000959": "sh000959",
                "399961": "sz399961", "000126": "sh000126", "000036": "sh000036",
                "399305": "sz399305", "000116": "sh000116", "399359": "sz399359",
                "399810": "sz399810", "000062": "sh000062", "399618": "sz399618",
                "399435": "sz399435", "000149": "sh000149", "000819": "sh000819",
                "000020": "sh000020", "000061": "sh000061", "000016": "sh000016",
                "000028": "sh000028", "399809": "sz399809", "000999": "sh000999",
                "399238": "sz399238", "000100": "sh000100", "399979": "sz399979",
                "000979": "sh000979", "399685": "sz399685", "000152": "sh000152",
                "000153": "sh000153", "399318": "sz399318", "000853": "sh000853",
                "000040": "sh000040", "399693": "sz399693", "000076": "sh000076",
                "000017": "sh000017", "000134": "sh000134", "399989": "sz399989",
                "000042": "sh000042", "000066": "sh000066", "000008": "sh000008",
                "000002": "sh000002", "000001": "sh000001", "000011": "sh000011",
                "000031": "sh000031", "399403": "sz399403", "000951": "sh000951",
                "399951": "sz399951", "000092": "sh000092", "399234": "sz399234",
                "000823": "sh000823", "399986": "sz399986", "399647": "sz399647",
                "000050": "sh000050", "000073": "sh000073", "399357": "sz399357",
                "000940": "sh000940", "000107": "sh000107", "000048": "sh000048",
                "399411": "sz399411", "399366": "sz399366", "399373": "sz399373",
                "000015": "sh000015", "000021": "sh000021", "000151": "sh000151",
                "000851": "sh000851", "000058": "sh000058", "399404": "sz399404",
                "399102": "sz399102", "399431": "sz399431", "399971": "sz399971",
                "000125": "sh000125", "000069": "sh000069", "000063": "sh000063",
                "399395": "sz399395", "000038": "sh000038", "399240": "sz399240",
                "399903": "sz399903", "000989": "sh000989", "399321": "sz399321",
                "399675": "sz399675", "399235": "sz399235", "000057": "sh000057",
                "000056": "sh000056", "000903": "sh000903", "399310": "sz399310",
                "000004": "sh000004", "000019": "sh000019", "399919": "sz399919",
                "000974": "sh000974", "000919": "sh000919", "399635": "sz399635",
                "399663": "sz399663", "399106": "sz399106", "399107": "sz399107",
                "399555": "sz399555", "000090": "sh000090", "000155": "sh000155",
                "000060": "sh000060", "399636": "sz399636", "000816": "sh000816",
                "000010": "sh000010", "399671": "sz399671", "000035": "sh000035",
                "399352": "sz399352", "399683": "sz399683", "399554": "sz399554",
                "399409": "sz399409", "000018": "sh000018", "399101": "sz399101",
                "000992": "sh000992", "399416": "sz399416", "399918": "sz399918",
                "399379": "sz399379", "399674": "sz399674", "399239": "sz399239",
                "399384": "sz399384", "399367": "sz399367", "000918": "sh000918",
                "000914": "sh000914", "399914": "sz399914", "000054": "sh000054",
                "000806": "sh000806", "399619": "sz399619", "399015": "sz399015",
                "399393": "sz399393", "399313": "sz399313", "399231": "sz399231",
                "000846": "sh000846", "000854": "sh000854", "399010": "sz399010",
                "399666": "sz399666", "399387": "sz399387", "399399": "sz399399",
                "000026": "sh000026", "399934": "sz399934", "000150": "sh000150",
                "000934": "sh000934", "399317": "sz399317", "000138": "sh000138",
                "399371": "sz399371", "399394": "sz399394", "399659": "sz399659",
                "399665": "sz399665", "399931": "sz399931", "000161": "sh000161",
                "399380": "sz399380", "000931": "sh000931", "399704": "sz399704",
                "399616": "sz399616", "000817": "sh000817", "399303": "sz399303",
                "399629": "sz399629", "399624": "sz399624", "399009": "sz399009",
                "399233": "sz399233", "399103": "sz399103", "399242": "sz399242",
                "399627": "sz399627", "000971": "sh000971", "399679": "sz399679",
                "399912": "sz399912", "000982": "sh000982", "399668": "sz399668",
                "000096": "sh000096", "399982": "sz399982", "000849": "sh000849",
                "000148": "sh000148", "399364": "sz399364", "000912": "sh000912",
                "000129": "sh000129", "000055": "sh000055", "000047": "sh000047",
                "399355": "sz399355", "399622": "sz399622", "000033": "sh000033",
                "399640": "sz399640", "000852": "sh000852", "399966": "sz399966",
                "399615": "sz399615", "399802": "sz399802", "399602": "sz399602",
                "000105": "sh000105", "399660": "sz399660", "399672": "sz399672",
                "399913": "sz399913", "399420": "sz399420", "000159": "sh000159",
                "399314": "sz399314", "399652": "sz399652",
                "399369": "sz399369", "000913": "sh000913", "000065": "sh000065",
                "000808": "sh000808", "399386": "sz399386", "399100": "sz399100",
                "000997": "sh000997", "000990": "sh000990", "000093": "sh000093",
                "399637": "sz399637", "399439": "sz399439", "399306": "sz399306",
                "000855": "sh000855", "000123": "sh000123", "399623": "sz399623",
                "399312": "sz399312", "399249": "sz399249", "399311": "sz399311",
                "399975": "sz399975", "399356": "sz399356",
                "399400": "sz399400", "399676": "sz399676", "000136": "sh000136",
                "399361": "sz399361", "399974": "sz399974", "399995": "sz399995",
                "399316": "sz399316", "399701": "sz399701", "000300": "sh000300",
                "000030": "sh000030", "000976": "sh000976", "399686": "sz399686",
                "399108": "sz399108", "399374": "sz399374",
                "000906": "sh000906", "399707": "sz399707", "000064": "sh000064",
                "399633": "sz399633", "399300": "sz399300", "399628": "sz399628",
                "399398": "sz399398", "000034": "sh000034",
                "399644": "sz399644", "399905": "sz399905", "399626": "sz399626",
                "399625": "sz399625", "000978": "sh000978", "399664": "sz399664",
                "399682": "sz399682", "399322": "sz399322", "000158": "sh000158",
                "000842": "sh000842", "399550": "sz399550", "399423": "sz399423",
                "399978": "sz399978", "399996": "sz399996", "000905": "sh000905",
                "000007": "sh000007", "000827": "sh000827", "399655": "sz399655",
                "399401": "sz399401", "399650": "sz399650", "000963": "sh000963",
                "399661": "sz399661", "399922": "sz399922", "000091": "sh000091",
                "399375": "sz399375", "000922": "sh000922", "399702": "sz399702",
                "399963": "sz399963", "399011": "sz399011", "399012": "sz399012",
                "399383": "sz399383", "399657": "sz399657", "399910": "sz399910",
                "399351": "sz399351", "000910": "sh000910", "000051": "sh000051",
                "399376": "sz399376", "399639": "sz399639", "000821": "sh000821",
                "399360": "sz399360", "399604": "sz399604", "399315": "sz399315",
                "399658": "sz399658", "000135": "sh000135",
                "000059": "sh000059", "399006": "sz399006",
                "399320": "sz399320", "000991": "sh000991", "399606": "sz399606",
                "399428": "sz399428", "399406": "sz399406", "399630": "sz399630",
                "000802": "sh000802", "399803": "sz399803", "000071": "sh000071", "399358": "sz399358",
                "399013": "sz399013", "399385": "sz399385", "399008": "sz399008", "399649": "sz399649",
                "399673": "sz399673", "399418": "sz399418", "399370": "sz399370", "000814": "sh000814",
                "399002": "sz399002", "399814": "sz399814", "399641": "sz399641", "399001": "sz399001",
                "399662": "sz399662", "399706": "sz399706", "399932": "sz399932", "000095": "sh000095",
                "000932": "sh000932", "399965": "sz399965", "399363": "sz399363", "399354": "sz399354",
                "399638": "sz399638", "399648": "sz399648", "399608": "sz399608", "000939": "sh000939",
                "399939": "sz399939", "399365": "sz399365", "399382": "sz399382", "399631": "sz399631",
                "399612": "sz399612", "399611": "sz399611", "399645": "sz399645",
                "399324": "sz399324", "399552": "sz399552", "000858": "sh000858", "000045": "sh000045",
                "000121": "sh000121", "399703": "sz399703", "399003": "sz399003",
                "399348": "sz399348", "399389": "sz399389", "399007": "sz399007", "399391": "sz399391",
                "000973": "sh000973",
                "000984": "sh000984", "000969": "sh000969", "000952": "sh000952", "399332": "sz399332",
                "399952": "sz399952",
                "399553": "sz399553", "000856": "sh000856",
                "399969": "sz399969", "399643": "sz399643", "399402": "sz399402", "399372": "sz399372",
                "399632": "sz399632",
                "399344": "sz399344", "399808": "sz399808", "399620": "sz399620", "000103": "sh000103",
                "399911": "sz399911",
                "000993": "sh000993", "000983": "sh000983", "399687": "sz399687", "399933": "sz399933",
                "000933": "sh000933",
                "399437": "sz399437", "399433": "sz399433", "000046": "sh000046", "000911": "sh000911",
                "000114": "sh000114",
                "000049": "sh000049", "399392": "sz399392", "399653": "sz399653", "000975": "sh000975",
                "000044": "sh000044",
                "399378": "sz399378", "000828": "sh000828", "399634": "sz399634",
                "399005": "sz399005", "000162": "sh000162", "399333": "sz399333", "000122": "sh000122",
                "399646": "sz399646",
                "000077": "sh000077", "000074": "sh000074", "399656": "sz399656", "399396": "sz399396",
                "399415": "sz399415",
                "399408": "sz399408", "000115": "sh000115", "000987": "sh000987", "399362": "sz399362",
                "000841": "sh000841",
                "000141": "sh000141", "000120": "sh000120", "399992": "sz399992", "000807": "sh000807",
                "399350": "sz399350",
                "000009": "sh000009", "000998": "sh000998", "399390": "sz399390", "399405": "sz399405",
                "000099": "sh000099",
                "399337": "sz399337", "000142": "sh000142", "399419": "sz399419", "399407": "sz399407",
                "000909": "sh000909",
                "000119": "sh000119", "399909": "sz399909", "399805": "sz399805", "000996": "sh000996",
                "000847": "sh000847",
                "000130": "sh000130", "399377": "sz399377", "399388": "sz399388", "399610": "sz399610",
                "000958": "sh000958",
                "399958": "sz399958", "000075": "sh000075", "399346": "sz399346", "000147": "sh000147",
                "000132": "sh000132",
                "000108": "sh000108", "399642": "sz399642", "000977": "sh000977", "399689": "sz399689",
                "399335": "sz399335",
                "399977": "sz399977", "399972": "sz399972", "399970": "sz399970", "399004": "sz399004",
                "399341": "sz399341",
                "399330": "sz399330", "399917": "sz399917", "000160": "sh000160", "399432": "sz399432",
                "399429": "sz399429", "000917": "sh000917",
                "000128": "sh000128", "000067": "sh000067", "000079": "sh000079", "399236": "sz399236",
                "399994": "sz399994",
                "399237": "sz399237", "000966": "sh000966", "000957": "sh000957", "399328": "sz399328",
                "399353": "sz399353", "399957": "sz399957", "399412": "sz399412", "000904": "sh000904",
                "399904": "sz399904",
                "399410": "sz399410", "000027": "sh000027", "399667": "sz399667", "000857": "sh000857",
                "000131": "sh000131", "000964": "sh000964", "399339": "sz399339", "399964": "sz399964",
                "399991": "sz399991",
                "399417": "sz399417", "000146": "sh000146", "399551": "sz399551", "000137": "sh000137",
                "000118": "sh000118",
                "399976": "sz399976", "000109": "sh000109", "399681": "sz399681", "399438": "sz399438",
                "000117": "sh000117",
                "399614": "sz399614", "399669": "sz399669", "000111": "sh000111", "399670": "sz399670",
                "000097": "sh000097",
                "000106": "sh000106", "000039": "sh000039", "399935": "sz399935", "000935": "sh000935",
                "399813": "sz399813",
                "000037": "sh000037", "399811": "sz399811", "399705": "sz399705", "399556": "sz399556",
                "000113": "sh000113",
                "000072": "sh000072", "399651": "sz399651", "399617": "sz399617", "399684": "sz399684",
                "000041": "sh000041",
                "399807": "sz399807", "399959": "sz399959", "399967": "sz399967", "399326": "sz399326",
                "399688": "sz399688",
                "399368": "sz399368", "399241": "sz399241", "399696": "sz399696", "000850": "sh000850",
                "000110": "sh000110",
                "399621": "sz399621", "399243": "sz399243",
                "399973": "sz399973", "399987": "sz399987", "000112": "sh000112", "399997": "sz399997",
                "000915": "sh000915", "000916": "sh000916",
                "hkHSI": "hkHSI"}

SLIST = ['180.153.18.170',
         '180.153.18.171',
         '202.108.253.130',
         '202.108.253.131',
         '60.191.117.167',
         '115.238.56.198',
         '218.75.126.9',
         '115.238.90.165',
         '124.160.88.183',
         '60.12.136.250',
         '218.108.98.244',
         '218.108.47.69',
         '14.17.75.71',
         '180.153.39.51']
XXLIST = ['61.152.107.141']
XLIST = ['121.14.110.210',
         '119.147.212.76',
         '113.105.73.86',
         '119.147.171.211',
         '119.147.164.57',
         '119.147.164.58',
         '61.49.50.180',
         '61.49.50.181',
         '61.135.142.85',
         '61.135.149.181',
         '114.80.80.210',
         '222.73.49.15',
         '221.194.181.176']
T_PORT = 7709
X_PORT = 7727

import sys

PY3 = (sys.version_info[0] >= 3)


def _write_head():
    sys.stdout.write(DATA_GETTING_TIPS)
    sys.stdout.flush()


def _write_console():
    sys.stdout.write(DATA_GETTING_FLAG)
    sys.stdout.flush()


def _write_tips(tip):
    sys.stdout.write(DATA_ROWS_TIPS % tip)
    sys.stdout.flush()


def _write_msg(msg):
    sys.stdout.write(msg)
    sys.stdout.flush()


def _check_input(year, quarter):
    if isinstance(year, str) or year < 1989:
        raise TypeError(DATE_CHK_MSG)
    elif quarter is None or isinstance(quarter, str) or quarter not in [1, 2, 3, 4]:
        raise TypeError(DATE_CHK_Q_MSG)
    else:
        return True


def _check_lhb_input(last):
    if last not in [5, 10, 30, 60]:
        raise TypeError(LHB_MSG)
    else:
        return True


def _code_to_symbol(code):
    """
        生成symbol代码标志
    """
    if code in INDEX_LABELS:
        return INDEX_LIST[code]
    else:
        if len(code) != 6:
            return code
        else:
            return 'sh%s' % code if code[:1] in ['5', '6', '9'] else 'sz%s' % code


def _code_to_symbol_dgt(code):
    """
        生成symbol代码标志
    """
    if code in INDEX_LABELS:
        return INDEX_LIST[code]
    else:
        if len(code) != 6:
            return code
        else:
            return '0%s' % code if code[:1] in ['5', '6', '9'] else '1%s' % code



trade_date_sse=['1990-12-19', '1990-12-20', '1990-12-21', '1990-12-24', '1990-12-25', '1990-12-26', '1990-12-27', '1990-12-28', '1990-12-31', '1991-01-02', '1991-01-03', '1991-01-04', '1991-01-07', '1991-01-08', '1991-01-09', '1991-01-10', '1991-01-11', '1991-01-14', '1991-01-15', '1991-01-16', '1991-01-17', '1991-01-18', '1991-01-21', '1991-01-22', '1991-01-23', '1991-01-24', '1991-01-25', '1991-01-28', '1991-01-29', '1991-01-30', '1991-01-31', '1991-02-01', '1991-02-04', '1991-02-05', '1991-02-06', '1991-02-07', '1991-02-08', '1991-02-11', '1991-02-12', '1991-02-13', '1991-02-14', '1991-02-19', '1991-02-20', '1991-02-21', '1991-02-22', '1991-02-25', '1991-02-26', '1991-02-27', '1991-02-28', '1991-03-01', '1991-03-04', '1991-03-05', '1991-03-06', '1991-03-07', '1991-03-08', '1991-03-11', '1991-03-12', '1991-03-13', '1991-03-14', '1991-03-15', '1991-03-18', '1991-03-19', '1991-03-20', '1991-03-21', '1991-03-22', '1991-03-25', '1991-03-26', '1991-03-27', '1991-03-28', '1991-03-29', '1991-04-01', '1991-04-02', '1991-04-03', '1991-04-04', '1991-04-05', '1991-04-08', '1991-04-09', '1991-04-10', '1991-04-11', '1991-04-12', '1991-04-15', '1991-04-16', '1991-04-17', '1991-04-18', '1991-04-19', '1991-04-22', '1991-04-23', '1991-04-24', '1991-04-25', '1991-04-26', '1991-04-29', '1991-04-30', '1991-05-02', '1991-05-03', '1991-05-06', '1991-05-07', '1991-05-08', '1991-05-09', '1991-05-10', '1991-05-13', '1991-05-14', '1991-05-15', '1991-05-16', '1991-05-17', '1991-05-20', '1991-05-21', '1991-05-22', '1991-05-23', '1991-05-24', '1991-05-27', '1991-05-28', '1991-05-29', '1991-05-30', '1991-05-31', '1991-06-03', '1991-06-04', '1991-06-05', '1991-06-06', '1991-06-07', '1991-06-10', '1991-06-11', '1991-06-12', '1991-06-13', '1991-06-14', '1991-06-17', '1991-06-18', '1991-06-19', '1991-06-20', '1991-06-21', '1991-06-24', '1991-06-25', '1991-06-26', '1991-06-27', '1991-06-28', '1991-07-01', '1991-07-02', '1991-07-03', '1991-07-04', '1991-07-05', '1991-07-08', '1991-07-09', '1991-07-10', '1991-07-11', '1991-07-12', '1991-07-15', '1991-07-16', '1991-07-17', '1991-07-18', '1991-07-19', '1991-07-22', '1991-07-23', '1991-07-24', '1991-07-25', '1991-07-26', '1991-07-29', '1991-07-30', '1991-07-31', '1991-08-01', '1991-08-02', '1991-08-05', '1991-08-06', '1991-08-07', '1991-08-08', '1991-08-09', '1991-08-12', '1991-08-13', '1991-08-14', '1991-08-15', '1991-08-16', '1991-08-19', '1991-08-20', '1991-08-21', '1991-08-22', '1991-08-23', '1991-08-26', '1991-08-27', '1991-08-28', '1991-08-29', '1991-08-30', '1991-09-02', '1991-09-03', '1991-09-04', '1991-09-05', '1991-09-06', '1991-09-09', '1991-09-10', '1991-09-11', '1991-09-12', '1991-09-13', '1991-09-16', '1991-09-17', '1991-09-18', '1991-09-19', '1991-09-20', '1991-09-23', '1991-09-24', '1991-09-25', '1991-09-26', '1991-09-27', '1991-09-30', '1991-10-03', '1991-10-04', '1991-10-07', '1991-10-08', '1991-10-09', '1991-10-10', '1991-10-11', '1991-10-14', '1991-10-15', '1991-10-16', '1991-10-17', '1991-10-18', '1991-10-21', '1991-10-22', '1991-10-23', '1991-10-24', '1991-10-25', '1991-10-28', '1991-10-29', '1991-10-30', '1991-10-31', '1991-11-01', '1991-11-04', '1991-11-05', '1991-11-06', '1991-11-07', '1991-11-08', '1991-11-11', '1991-11-12', '1991-11-13', '1991-11-14', '1991-11-15', '1991-11-18', '1991-11-19', '1991-11-20', '1991-11-21', '1991-11-22', '1991-11-25', '1991-11-26', '1991-11-27', '1991-11-28', '1991-11-29', '1991-12-02', '1991-12-03', '1991-12-04', '1991-12-05', '1991-12-06', '1991-12-09', '1991-12-10', '1991-12-11', '1991-12-12', '1991-12-13', '1991-12-16', '1991-12-17', '1991-12-18', '1991-12-19', '1991-12-20', '1991-12-23', '1991-12-24', '1991-12-25', '1991-12-26', '1991-12-27', '1991-12-30', '1991-12-31', '1992-01-02', '1992-01-03', '1992-01-06', '1992-01-07', '1992-01-08', '1992-01-09', '1992-01-10', '1992-01-13', '1992-01-14', '1992-01-15', '1992-01-16', '1992-01-17', '1992-01-20', '1992-01-21', '1992-01-22', '1992-01-23', '1992-01-24', '1992-01-27', '1992-01-28', '1992-01-29', '1992-01-30', '1992-01-31', '1992-02-03', '1992-02-07', '1992-02-10', '1992-02-11', '1992-02-12', '1992-02-13', '1992-02-14', '1992-02-17', '1992-02-18', '1992-02-19', '1992-02-20', '1992-02-21', '1992-02-24', '1992-02-25', '1992-02-26', '1992-02-27', '1992-02-28', '1992-03-02', '1992-03-03', '1992-03-04', '1992-03-05', '1992-03-06', '1992-03-09', '1992-03-10', '1992-03-11', '1992-03-12', '1992-03-13', '1992-03-16', '1992-03-17', '1992-03-18', '1992-03-19', '1992-03-20', '1992-03-23', '1992-03-24', '1992-03-25', '1992-03-26', '1992-03-27', '1992-03-30', '1992-03-31', '1992-04-01', '1992-04-02', '1992-04-03', '1992-04-06', '1992-04-07', '1992-04-08', '1992-04-09', '1992-04-10', '1992-04-13', '1992-04-14', '1992-04-15', '1992-04-16', '1992-04-17', '1992-04-20', '1992-04-21', '1992-04-22', '1992-04-23', '1992-04-24', '1992-04-27', '1992-04-28', '1992-04-29', '1992-04-30', '1992-05-04', '1992-05-05', '1992-05-06', '1992-05-07', '1992-05-08', '1992-05-11', '1992-05-12', '1992-05-13', '1992-05-14', '1992-05-15', '1992-05-18', '1992-05-19', '1992-05-20', '1992-05-21', '1992-05-22', '1992-05-25', '1992-05-26', '1992-05-27', '1992-05-28', '1992-05-29', '1992-06-01', '1992-06-02', '1992-06-03', '1992-06-04', '1992-06-05', '1992-06-08', '1992-06-09', '1992-06-10', '1992-06-11', '1992-06-12', '1992-06-15', '1992-06-16', '1992-06-17', '1992-06-18', '1992-06-19', '1992-06-22', '1992-06-23', '1992-06-24', '1992-06-25', '1992-06-26', '1992-06-29', '1992-06-30', '1992-07-01', '1992-07-02', '1992-07-03', '1992-07-06', '1992-07-07', '1992-07-08', '1992-07-09', '1992-07-10', '1992-07-13', '1992-07-14', '1992-07-15', '1992-07-16', '1992-07-17', '1992-07-20', '1992-07-21', '1992-07-22', '1992-07-23', '1992-07-24', '1992-07-27', '1992-07-28', '1992-07-29', '1992-07-30', '1992-07-31', '1992-08-03', '1992-08-04', '1992-08-05', '1992-08-06', '1992-08-07', '1992-08-10', '1992-08-11', '1992-08-12', '1992-08-13', '1992-08-14', '1992-08-17', '1992-08-18', '1992-08-19', '1992-08-20', '1992-08-21', '1992-08-24', '1992-08-25', '1992-08-26', '1992-08-27', '1992-08-28', '1992-08-31', '1992-09-01', '1992-09-02', '1992-09-03', '1992-09-04', '1992-09-07', '1992-09-08', '1992-09-09', '1992-09-10', '1992-09-11', '1992-09-14', '1992-09-15', '1992-09-16', '1992-09-17', '1992-09-18', '1992-09-21', '1992-09-22', '1992-09-23', '1992-09-24', '1992-09-25', '1992-09-28', '1992-09-29', '1992-09-30', '1992-10-05', '1992-10-06', '1992-10-07', '1992-10-08', '1992-10-09', '1992-10-12', '1992-10-13', '1992-10-14', '1992-10-15', '1992-10-16', '1992-10-19', '1992-10-20', '1992-10-21', '1992-10-22', '1992-10-23', '1992-10-26', '1992-10-27', '1992-10-28', '1992-10-29', '1992-10-30', '1992-11-02', '1992-11-03', '1992-11-04', '1992-11-05', '1992-11-06', '1992-11-09', '1992-11-10', '1992-11-11', '1992-11-12', '1992-11-13', '1992-11-16', '1992-11-17', '1992-11-18', '1992-11-19', '1992-11-20', '1992-11-23', '1992-11-24', '1992-11-25', '1992-11-26', '1992-11-27', '1992-11-30', '1992-12-01', '1992-12-02', '1992-12-03', '1992-12-04', '1992-12-07', '1992-12-08', '1992-12-09', '1992-12-10', '1992-12-11', '1992-12-14', '1992-12-15', '1992-12-16', '1992-12-17', '1992-12-18', '1992-12-21', '1992-12-22', '1992-12-23', '1992-12-24', '1992-12-25', '1992-12-28', '1992-12-29', '1992-12-30', '1992-12-31', '1993-01-04', '1993-01-05', '1993-01-06', '1993-01-07', '1993-01-08', '1993-01-11', '1993-01-12', '1993-01-13', '1993-01-14', '1993-01-15', '1993-01-18', '1993-01-19', '1993-01-20', '1993-01-21', '1993-01-22', '1993-01-27', '1993-01-28', '1993-01-29', '1993-02-01', '1993-02-02', '1993-02-03', '1993-02-04', '1993-02-05', '1993-02-08', '1993-02-09', '1993-02-10', '1993-02-11', '1993-02-12', '1993-02-15', '1993-02-16', '1993-02-17', '1993-02-18', '1993-02-19', '1993-02-22', '1993-02-23', '1993-02-24', '1993-02-25', '1993-02-26', '1993-03-01', '1993-03-02', '1993-03-03', '1993-03-04', '1993-03-05', '1993-03-08', '1993-03-09', '1993-03-10', '1993-03-11', '1993-03-12', '1993-03-15', '1993-03-16', '1993-03-17', '1993-03-18', '1993-03-19', '1993-03-22', '1993-03-23', '1993-03-24', '1993-03-25', '1993-03-26', '1993-03-29', '1993-03-30', '1993-03-31', '1993-04-01', '1993-04-02', '1993-04-05', '1993-04-06', '1993-04-07', '1993-04-08', '1993-04-09', '1993-04-12', '1993-04-13', '1993-04-14', '1993-04-15', '1993-04-16', '1993-04-19', '1993-04-20', '1993-04-21', '1993-04-22', '1993-04-23', '1993-04-26', '1993-04-27', '1993-04-28', '1993-04-29', '1993-04-30', '1993-05-03', '1993-05-04', '1993-05-05', '1993-05-06', '1993-05-07', '1993-05-10', '1993-05-11', '1993-05-12', '1993-05-13', '1993-05-14', '1993-05-17', '1993-05-18', '1993-05-19', '1993-05-20', '1993-05-21', '1993-05-24', '1993-05-25', '1993-05-26', '1993-05-27', '1993-05-28', '1993-05-31', '1993-06-01', '1993-06-02', '1993-06-03', '1993-06-04', '1993-06-07', '1993-06-08', '1993-06-09', '1993-06-10', '1993-06-11', '1993-06-14', '1993-06-15', '1993-06-16', '1993-06-17', '1993-06-18', '1993-06-21', '1993-06-22', '1993-06-23', '1993-06-24', '1993-06-25', '1993-06-28', '1993-06-29', '1993-06-30', '1993-07-01', '1993-07-02', '1993-07-05', '1993-07-06', '1993-07-07', '1993-07-08', '1993-07-09', '1993-07-12', '1993-07-13', '1993-07-14', '1993-07-15', '1993-07-16', '1993-07-19', '1993-07-20', '1993-07-21', '1993-07-22', '1993-07-23', '1993-07-26', '1993-07-27', '1993-07-28', '1993-07-29', '1993-07-30', '1993-08-02', '1993-08-03', '1993-08-04', '1993-08-05', '1993-08-06', '1993-08-09', '1993-08-10', '1993-08-11', '1993-08-12', '1993-08-13', '1993-08-16', '1993-08-17', '1993-08-18', '1993-08-19', '1993-08-20', '1993-08-23', '1993-08-24', '1993-08-25', '1993-08-26', '1993-08-27', '1993-08-30', '1993-08-31', '1993-09-01', '1993-09-02', '1993-09-03', '1993-09-06', '1993-09-07', '1993-09-08', '1993-09-09', '1993-09-10', '1993-09-13', '1993-09-14', '1993-09-15', '1993-09-16', '1993-09-17', '1993-09-20', '1993-09-21', '1993-09-22', '1993-09-23', '1993-09-24', '1993-09-27', '1993-09-28', '1993-09-29', '1993-09-30', '1993-10-04', '1993-10-05', '1993-10-06', '1993-10-07', '1993-10-08', '1993-10-11', '1993-10-12', '1993-10-13', '1993-10-14', '1993-10-15', '1993-10-18', '1993-10-19', '1993-10-20', '1993-10-21', '1993-10-22', '1993-10-25', '1993-10-26', '1993-10-27', '1993-10-28', '1993-10-29', '1993-11-01', '1993-11-02', '1993-11-03', '1993-11-04', '1993-11-05', '1993-11-08', '1993-11-09', '1993-11-10', '1993-11-11', '1993-11-12', '1993-11-15', '1993-11-16', '1993-11-17', '1993-11-18', '1993-11-19', '1993-11-22', '1993-11-23', '1993-11-24', '1993-11-25', '1993-11-26', '1993-11-29', '1993-11-30', '1993-12-01', '1993-12-02', '1993-12-03', '1993-12-06', '1993-12-07', '1993-12-08', '1993-12-09', '1993-12-10', '1993-12-13', '1993-12-14', '1993-12-15', '1993-12-16', '1993-12-17', '1993-12-20', '1993-12-21', '1993-12-22', '1993-12-23', '1993-12-24', '1993-12-27', '1993-12-28', '1993-12-29', '1993-12-30', '1993-12-31', '1994-01-03', '1994-01-04', '1994-01-05', '1994-01-06', '1994-01-07', '1994-01-10', '1994-01-11', '1994-01-12', '1994-01-13', '1994-01-14', '1994-01-17', '1994-01-18', '1994-01-19', '1994-01-20', '1994-01-21', '1994-01-24', '1994-01-25', '1994-01-26', '1994-01-27', '1994-01-28', '1994-01-31', '1994-02-01', '1994-02-02', '1994-02-03', '1994-02-04', '1994-02-14', '1994-02-15', '1994-02-16', '1994-02-17', '1994-02-18', '1994-02-21', '1994-02-22', '1994-02-23', '1994-02-24', '1994-02-25', '1994-02-28', '1994-03-01', '1994-03-02', '1994-03-03', '1994-03-04', '1994-03-07', '1994-03-08', '1994-03-09', '1994-03-10', '1994-03-11', '1994-03-14', '1994-03-15', '1994-03-16', '1994-03-17', '1994-03-18', '1994-03-21', '1994-03-22', '1994-03-23', '1994-03-24', '1994-03-25', '1994-03-28', '1994-03-29', '1994-03-30', '1994-03-31', '1994-04-01', '1994-04-04', '1994-04-05', '1994-04-06', '1994-04-07', '1994-04-08', '1994-04-11', '1994-04-12', '1994-04-13', '1994-04-14', '1994-04-15', '1994-04-18', '1994-04-19', '1994-04-20', '1994-04-21', '1994-04-22', '1994-04-25', '1994-04-26', '1994-04-27', '1994-04-28', '1994-04-29', '1994-05-03', '1994-05-04', '1994-05-05', '1994-05-06', '1994-05-09', '1994-05-10', '1994-05-11', '1994-05-12', '1994-05-13', '1994-05-16', '1994-05-17', '1994-05-18', '1994-05-19', '1994-05-20', '1994-05-23', '1994-05-24', '1994-05-25', '1994-05-26', '1994-05-27', '1994-05-30', '1994-05-31', '1994-06-01', '1994-06-02', '1994-06-03', '1994-06-06', '1994-06-07', '1994-06-08', '1994-06-09', '1994-06-10', '1994-06-13', '1994-06-14', '1994-06-15', '1994-06-16', '1994-06-17', '1994-06-20', '1994-06-21', '1994-06-22', '1994-06-23', '1994-06-24', '1994-06-27', '1994-06-28', '1994-06-29', '1994-06-30', '1994-07-01', '1994-07-04', '1994-07-05', '1994-07-06', '1994-07-07', '1994-07-08', '1994-07-11', '1994-07-12', '1994-07-13', '1994-07-14', '1994-07-15', '1994-07-18', '1994-07-19', '1994-07-20', '1994-07-21', '1994-07-22', '1994-07-25', '1994-07-26', '1994-07-27', '1994-07-28', '1994-07-29', '1994-08-01', '1994-08-02', '1994-08-03', '1994-08-04', '1994-08-05', '1994-08-08', '1994-08-09', '1994-08-10', '1994-08-11', '1994-08-12', '1994-08-15', '1994-08-16', '1994-08-17', '1994-08-18', '1994-08-19', '1994-08-22', '1994-08-23', '1994-08-24', '1994-08-25', '1994-08-26', '1994-08-29', '1994-08-30', '1994-08-31', '1994-09-01', '1994-09-02', '1994-09-05', '1994-09-06', '1994-09-07', '1994-09-08', '1994-09-09', '1994-09-12', '1994-09-13', '1994-09-14', '1994-09-15', '1994-09-16', '1994-09-19', '1994-09-20', '1994-09-21', '1994-09-22', '1994-09-23', '1994-09-26', '1994-09-27', '1994-09-28', '1994-09-29', '1994-09-30', '1994-10-05', '1994-10-06', '1994-10-07', '1994-10-10', '1994-10-11', '1994-10-12', '1994-10-13', '1994-10-14', '1994-10-17', '1994-10-18', '1994-10-19', '1994-10-20', '1994-10-21', '1994-10-24', '1994-10-25', '1994-10-26', '1994-10-27', '1994-10-28', '1994-10-31', '1994-11-01', '1994-11-02', '1994-11-03', '1994-11-04', '1994-11-07', '1994-11-08', '1994-11-09', '1994-11-10', '1994-11-11', '1994-11-14', '1994-11-15', '1994-11-16', '1994-11-17', '1994-11-18', '1994-11-21', '1994-11-22', '1994-11-23', '1994-11-24', '1994-11-25', '1994-11-28', '1994-11-29', '1994-11-30', '1994-12-01', '1994-12-02', '1994-12-05', '1994-12-06', '1994-12-07', '1994-12-08', '1994-12-09', '1994-12-12', '1994-12-13', '1994-12-14', '1994-12-15', '1994-12-16', '1994-12-19', '1994-12-20', '1994-12-21', '1994-12-22', '1994-12-23', '1994-12-26', '1994-12-27', '1994-12-28', '1994-12-29', '1994-12-30', '1995-01-03', '1995-01-04', '1995-01-05', '1995-01-06', '1995-01-09', '1995-01-10', '1995-01-11', '1995-01-12', '1995-01-13', '1995-01-16', '1995-01-17', '1995-01-18', '1995-01-19', '1995-01-20', '1995-01-23', '1995-01-24', '1995-01-25', '1995-01-26', '1995-01-27', '1995-02-06', '1995-02-07', '1995-02-08', '1995-02-09', '1995-02-10', '1995-02-13', '1995-02-14', '1995-02-15', '1995-02-16', '1995-02-17', '1995-02-20', '1995-02-21', '1995-02-22', '1995-02-23', '1995-02-24', '1995-02-27', '1995-02-28', '1995-03-01', '1995-03-02', '1995-03-03', '1995-03-06', '1995-03-07', '1995-03-08', '1995-03-09', '1995-03-10', '1995-03-13', '1995-03-14', '1995-03-15', '1995-03-16', '1995-03-17', '1995-03-20', '1995-03-21', '1995-03-22', '1995-03-23', '1995-03-24', '1995-03-27', '1995-03-28', '1995-03-29', '1995-03-30', '1995-03-31', '1995-04-03', '1995-04-04', '1995-04-05', '1995-04-06', '1995-04-07', '1995-04-10', '1995-04-11', '1995-04-12', '1995-04-13', '1995-04-14', '1995-04-17', '1995-04-18', '1995-04-19', '1995-04-20', '1995-04-21', '1995-04-24', '1995-04-25', '1995-04-26', '1995-04-27', '1995-04-28', '1995-05-02', '1995-05-03', '1995-05-04', '1995-05-05', '1995-05-08', '1995-05-09', '1995-05-10', '1995-05-11', '1995-05-12', '1995-05-15', '1995-05-16', '1995-05-17', '1995-05-18', '1995-05-19', '1995-05-22', '1995-05-23', '1995-05-24', '1995-05-25', '1995-05-26', '1995-05-29', '1995-05-30', '1995-05-31', '1995-06-01', '1995-06-02', '1995-06-05', '1995-06-06', '1995-06-07', '1995-06-08', '1995-06-09', '1995-06-12', '1995-06-13', '1995-06-14', '1995-06-15', '1995-06-16', '1995-06-19', '1995-06-20', '1995-06-21', '1995-06-22', '1995-06-23', '1995-06-26', '1995-06-27', '1995-06-28', '1995-06-29', '1995-06-30', '1995-07-03', '1995-07-04', '1995-07-05', '1995-07-06', '1995-07-07', '1995-07-10', '1995-07-11', '1995-07-12', '1995-07-13', '1995-07-14', '1995-07-17', '1995-07-18', '1995-07-19', '1995-07-20', '1995-07-21', '1995-07-24', '1995-07-25', '1995-07-26', '1995-07-27', '1995-07-28', '1995-07-31', '1995-08-01', '1995-08-02', '1995-08-03', '1995-08-04', '1995-08-07', '1995-08-08', '1995-08-09', '1995-08-10', '1995-08-11', '1995-08-14', '1995-08-15', '1995-08-16', '1995-08-17', '1995-08-18', '1995-08-21', '1995-08-22', '1995-08-23', '1995-08-24', '1995-08-25', '1995-08-28', '1995-08-29', '1995-08-30', '1995-08-31', '1995-09-01', '1995-09-04', '1995-09-05', '1995-09-06', '1995-09-07', '1995-09-08', '1995-09-11', '1995-09-12', '1995-09-13', '1995-09-14', '1995-09-15', '1995-09-18', '1995-09-19', '1995-09-20', '1995-09-21', '1995-09-22', '1995-09-25', '1995-09-26', '1995-09-27', '1995-09-28', '1995-09-29', '1995-10-04', '1995-10-05', '1995-10-06', '1995-10-09', '1995-10-10', '1995-10-11', '1995-10-12', '1995-10-13', '1995-10-16', '1995-10-17', '1995-10-18', '1995-10-19', '1995-10-20', '1995-10-23', '1995-10-24', '1995-10-25', '1995-10-26', '1995-10-27', '1995-10-30', '1995-10-31', '1995-11-01', '1995-11-02', '1995-11-03', '1995-11-06', '1995-11-07', '1995-11-08', '1995-11-09', '1995-11-10', '1995-11-13', '1995-11-14', '1995-11-15', '1995-11-16', '1995-11-17', '1995-11-20', '1995-11-21', '1995-11-22', '1995-11-23', '1995-11-24', '1995-11-27', '1995-11-28', '1995-11-29', '1995-11-30', '1995-12-01', '1995-12-04', '1995-12-05', '1995-12-06', '1995-12-07', '1995-12-08', '1995-12-11', '1995-12-12', '1995-12-13', '1995-12-14', '1995-12-15', '1995-12-18', '1995-12-19', '1995-12-20', '1995-12-21', '1995-12-22', '1995-12-25', '1995-12-26', '1995-12-27', '1995-12-28', '1995-12-29', '1996-01-02', '1996-01-03', '1996-01-04', '1996-01-05', '1996-01-08', '1996-01-09', '1996-01-10', '1996-01-11', '1996-01-12', '1996-01-15', '1996-01-16', '1996-01-17', '1996-01-18', '1996-01-19', '1996-01-22', '1996-01-23', '1996-01-24', '1996-01-25', '1996-01-26', '1996-01-29', '1996-01-30', '1996-01-31', '1996-02-01', '1996-02-02', '1996-02-05', '1996-02-06', '1996-02-07', '1996-02-08', '1996-02-09', '1996-02-12', '1996-02-13', '1996-02-14', '1996-02-15', '1996-02-16', '1996-03-04', '1996-03-05', '1996-03-06', '1996-03-07', '1996-03-08', '1996-03-11', '1996-03-12', '1996-03-13', '1996-03-14', '1996-03-15', '1996-03-18', '1996-03-19', '1996-03-20', '1996-03-21', '1996-03-22', '1996-03-25', '1996-03-26', '1996-03-27', '1996-03-28', '1996-03-29', '1996-04-01', '1996-04-02', '1996-04-03', '1996-04-04', '1996-04-05', '1996-04-08', '1996-04-09', '1996-04-10', '1996-04-11', '1996-04-12', '1996-04-15', '1996-04-16', '1996-04-17', '1996-04-18', '1996-04-19', '1996-04-22', '1996-04-23', '1996-04-24', '1996-04-25', '1996-04-26', '1996-04-29', '1996-04-30', '1996-05-02', '1996-05-03', '1996-05-06', '1996-05-07', '1996-05-08', '1996-05-09', '1996-05-10', '1996-05-13', '1996-05-14', '1996-05-15', '1996-05-16', '1996-05-17', '1996-05-20', '1996-05-21', '1996-05-22', '1996-05-23', '1996-05-24', '1996-05-27', '1996-05-28', '1996-05-29', '1996-05-30', '1996-05-31', '1996-06-03', '1996-06-04', '1996-06-05', '1996-06-06', '1996-06-07', '1996-06-10', '1996-06-11', '1996-06-12', '1996-06-13', '1996-06-14', '1996-06-17', '1996-06-18', '1996-06-19', '1996-06-20', '1996-06-21', '1996-06-24', '1996-06-25', '1996-06-26', '1996-06-27', '1996-06-28', '1996-07-01', '1996-07-02', '1996-07-03', '1996-07-04', '1996-07-05', '1996-07-08', '1996-07-09', '1996-07-10', '1996-07-11', '1996-07-12', '1996-07-15', '1996-07-16', '1996-07-17', '1996-07-18', '1996-07-19', '1996-07-22', '1996-07-23', '1996-07-24', '1996-07-25', '1996-07-26', '1996-07-29', '1996-07-30', '1996-07-31', '1996-08-01', '1996-08-02', '1996-08-05', '1996-08-06', '1996-08-07', '1996-08-08', '1996-08-09', '1996-08-12', '1996-08-13', '1996-08-14', '1996-08-15', '1996-08-16', '1996-08-19', '1996-08-20', '1996-08-21', '1996-08-22', '1996-08-23', '1996-08-26', '1996-08-27', '1996-08-28', '1996-08-29', '1996-08-30', '1996-09-02', '1996-09-03', '1996-09-04', '1996-09-05', '1996-09-06', '1996-09-09', '1996-09-10', '1996-09-11', '1996-09-12', '1996-09-13', '1996-09-16', '1996-09-17', '1996-09-18', '1996-09-19', '1996-09-20', '1996-09-23', '1996-09-24', '1996-09-25', '1996-09-26', '1996-09-27', '1996-10-03', '1996-10-04', '1996-10-07', '1996-10-08', '1996-10-09', '1996-10-10', '1996-10-11', '1996-10-14', '1996-10-15', '1996-10-16', '1996-10-17', '1996-10-18', '1996-10-21', '1996-10-22', '1996-10-23', '1996-10-24', '1996-10-25', '1996-10-28', '1996-10-29', '1996-10-30', '1996-10-31', '1996-11-01', '1996-11-04', '1996-11-05', '1996-11-06', '1996-11-07', '1996-11-08', '1996-11-11', '1996-11-12', '1996-11-13', '1996-11-14', '1996-11-15', '1996-11-18', '1996-11-19', '1996-11-20', '1996-11-21', '1996-11-22', '1996-11-25', '1996-11-26', '1996-11-27', '1996-11-28', '1996-11-29', '1996-12-02', '1996-12-03', '1996-12-04', '1996-12-05', '1996-12-06', '1996-12-09', '1996-12-10', '1996-12-11', '1996-12-12', '1996-12-13', '1996-12-16', '1996-12-17', '1996-12-18', '1996-12-19', '1996-12-20', '1996-12-23', '1996-12-24', '1996-12-25', '1996-12-26', '1996-12-27', '1996-12-30', '1996-12-31', '1997-01-02', '1997-01-03', '1997-01-06', '1997-01-07', '1997-01-08', '1997-01-09', '1997-01-10', '1997-01-13', '1997-01-14', '1997-01-15', '1997-01-16', '1997-01-17', '1997-01-20', '1997-01-21', '1997-01-22', '1997-01-23', '1997-01-24', '1997-01-27', '1997-01-28', '1997-01-29', '1997-01-30', '1997-01-31', '1997-02-17', '1997-02-18', '1997-02-19', '1997-02-20', '1997-02-21', '1997-02-24', '1997-02-25', '1997-02-26', '1997-02-27', '1997-02-28', '1997-03-03', '1997-03-04', '1997-03-05', '1997-03-06', '1997-03-07', '1997-03-10', '1997-03-11', '1997-03-12', '1997-03-13', '1997-03-14', '1997-03-17', '1997-03-18', '1997-03-19', '1997-03-20', '1997-03-21', '1997-03-24', '1997-03-25', '1997-03-26', '1997-03-27', '1997-03-28', '1997-03-31', '1997-04-01', '1997-04-02', '1997-04-03', '1997-04-04', '1997-04-07', '1997-04-08', '1997-04-09', '1997-04-10', '1997-04-11', '1997-04-14', '1997-04-15', '1997-04-16', '1997-04-17', '1997-04-18', '1997-04-21', '1997-04-22', '1997-04-23', '1997-04-24', '1997-04-25', '1997-04-28', '1997-04-29', '1997-04-30', '1997-05-05', '1997-05-06', '1997-05-07', '1997-05-08', '1997-05-09', '1997-05-12', '1997-05-13', '1997-05-14', '1997-05-15', '1997-05-16', '1997-05-19', '1997-05-20', '1997-05-21', '1997-05-22', '1997-05-23', '1997-05-26', '1997-05-27', '1997-05-28', '1997-05-29', '1997-05-30', '1997-06-02', '1997-06-03', '1997-06-04', '1997-06-05', '1997-06-06', '1997-06-09', '1997-06-10', '1997-06-11', '1997-06-12', '1997-06-13', '1997-06-16', '1997-06-17', '1997-06-18', '1997-06-19', '1997-06-20', '1997-06-23', '1997-06-24', '1997-06-25', '1997-06-26', '1997-06-27', '1997-07-02', '1997-07-03', '1997-07-04', '1997-07-07', '1997-07-08', '1997-07-09', '1997-07-10', '1997-07-11', '1997-07-14', '1997-07-15', '1997-07-16', '1997-07-17', '1997-07-18', '1997-07-21', '1997-07-22', '1997-07-23', '1997-07-24', '1997-07-25', '1997-07-28', '1997-07-29', '1997-07-30', '1997-07-31', '1997-08-01', '1997-08-04', '1997-08-05', '1997-08-06', '1997-08-07', '1997-08-08', '1997-08-11', '1997-08-12', '1997-08-13', '1997-08-14', '1997-08-15', '1997-08-18', '1997-08-19', '1997-08-20', '1997-08-21', '1997-08-22', '1997-08-25', '1997-08-26', '1997-08-27', '1997-08-28', '1997-08-29', '1997-09-01', '1997-09-02', '1997-09-03', '1997-09-04', '1997-09-05', '1997-09-08', '1997-09-09', '1997-09-10', '1997-09-11', '1997-09-12', '1997-09-15', '1997-09-16', '1997-09-17', '1997-09-18', '1997-09-19', '1997-09-22', '1997-09-23', '1997-09-24', '1997-09-25', '1997-09-26', '1997-09-29', '1997-09-30', '1997-10-06', '1997-10-07', '1997-10-08', '1997-10-09', '1997-10-10', '1997-10-13', '1997-10-14', '1997-10-15', '1997-10-16', '1997-10-17', '1997-10-20', '1997-10-21', '1997-10-22', '1997-10-23', '1997-10-24', '1997-10-27', '1997-10-28', '1997-10-29', '1997-10-30', '1997-10-31', '1997-11-03', '1997-11-04', '1997-11-05', '1997-11-06', '1997-11-07', '1997-11-10', '1997-11-11', '1997-11-12', '1997-11-13', '1997-11-14', '1997-11-17', '1997-11-18', '1997-11-19', '1997-11-20', '1997-11-21', '1997-11-24', '1997-11-25', '1997-11-26', '1997-11-27', '1997-11-28', '1997-12-01', '1997-12-02', '1997-12-03', '1997-12-04', '1997-12-05', '1997-12-08', '1997-12-09', '1997-12-10', '1997-12-11', '1997-12-12', '1997-12-15', '1997-12-16', '1997-12-17', '1997-12-18', '1997-12-19', '1997-12-22', '1997-12-23', '1997-12-24', '1997-12-25', '1997-12-26', '1997-12-29', '1997-12-30', '1997-12-31', '1998-01-05', '1998-01-06', '1998-01-07', '1998-01-08', '1998-01-09', '1998-01-12', '1998-01-13', '1998-01-14', '1998-01-15', '1998-01-16', '1998-01-19', '1998-01-20', '1998-01-21', '1998-01-22', '1998-01-23', '1998-02-09', '1998-02-10', '1998-02-11', '1998-02-12', '1998-02-13', '1998-02-16', '1998-02-17', '1998-02-18', '1998-02-19', '1998-02-20', '1998-02-23', '1998-02-24', '1998-02-25', '1998-02-26', '1998-02-27', '1998-03-02', '1998-03-03', '1998-03-04', '1998-03-05', '1998-03-06', '1998-03-09', '1998-03-10', '1998-03-11', '1998-03-12', '1998-03-13', '1998-03-16', '1998-03-17', '1998-03-18', '1998-03-19', '1998-03-20', '1998-03-23', '1998-03-24', '1998-03-25', '1998-03-26', '1998-03-27', '1998-03-30', '1998-03-31', '1998-04-01', '1998-04-02', '1998-04-03', '1998-04-06', '1998-04-07', '1998-04-08', '1998-04-09', '1998-04-10', '1998-04-13', '1998-04-14', '1998-04-15', '1998-04-16', '1998-04-17', '1998-04-20', '1998-04-21', '1998-04-22', '1998-04-23', '1998-04-24', '1998-04-27', '1998-04-28', '1998-04-29', '1998-04-30', '1998-05-04', '1998-05-05', '1998-05-06', '1998-05-07', '1998-05-08', '1998-05-11', '1998-05-12', '1998-05-13', '1998-05-14', '1998-05-15', '1998-05-18', '1998-05-19', '1998-05-20', '1998-05-21', '1998-05-22', '1998-05-25', '1998-05-26', '1998-05-27', '1998-05-28', '1998-05-29', '1998-06-01', '1998-06-02', '1998-06-03', '1998-06-04', '1998-06-05', '1998-06-08', '1998-06-09', '1998-06-10', '1998-06-11', '1998-06-12', '1998-06-15', '1998-06-16', '1998-06-17', '1998-06-18', '1998-06-19', '1998-06-22', '1998-06-23', '1998-06-24', '1998-06-25', '1998-06-26', '1998-06-29', '1998-06-30', '1998-07-01', '1998-07-02', '1998-07-03', '1998-07-06', '1998-07-07', '1998-07-08', '1998-07-09', '1998-07-10', '1998-07-13', '1998-07-14', '1998-07-15', '1998-07-16', '1998-07-17', '1998-07-20', '1998-07-21', '1998-07-22', '1998-07-23', '1998-07-24', '1998-07-27', '1998-07-28', '1998-07-29', '1998-07-30', '1998-07-31', '1998-08-03', '1998-08-04', '1998-08-05', '1998-08-06', '1998-08-07', '1998-08-10', '1998-08-11', '1998-08-12', '1998-08-13', '1998-08-14', '1998-08-17', '1998-08-18', '1998-08-19', '1998-08-20', '1998-08-21', '1998-08-24', '1998-08-25', '1998-08-26', '1998-08-27', '1998-08-28', '1998-08-31', '1998-09-01', '1998-09-02', '1998-09-03', '1998-09-04', '1998-09-07', '1998-09-08', '1998-09-09', '1998-09-10', '1998-09-11', '1998-09-14', '1998-09-15', '1998-09-16', '1998-09-17', '1998-09-18', '1998-09-21', '1998-09-22', '1998-09-23', '1998-09-24', '1998-09-25', '1998-09-28', '1998-09-29', '1998-09-30', '1998-10-05', '1998-10-06', '1998-10-07', '1998-10-08', '1998-10-09', '1998-10-12', '1998-10-13', '1998-10-14', '1998-10-15', '1998-10-16', '1998-10-19', '1998-10-20', '1998-10-21', '1998-10-22', '1998-10-23', '1998-10-26', '1998-10-27', '1998-10-28', '1998-10-29', '1998-10-30', '1998-11-02', '1998-11-03', '1998-11-04', '1998-11-05', '1998-11-06', '1998-11-09', '1998-11-10', '1998-11-11', '1998-11-12', '1998-11-13', '1998-11-16', '1998-11-17', '1998-11-18', '1998-11-19', '1998-11-20', '1998-11-23', '1998-11-24', '1998-11-25', '1998-11-26', '1998-11-27', '1998-11-30', '1998-12-01', '1998-12-02', '1998-12-03', '1998-12-04', '1998-12-07', '1998-12-08', '1998-12-09', '1998-12-10', '1998-12-11', '1998-12-14', '1998-12-15', '1998-12-16', '1998-12-17', '1998-12-18', '1998-12-21', '1998-12-22', '1998-12-23', '1998-12-24', '1998-12-25', '1998-12-28', '1998-12-29', '1998-12-30', '1998-12-31', '1999-01-04', '1999-01-05', '1999-01-06', '1999-01-07', '1999-01-08', '1999-01-11', '1999-01-12', '1999-01-13', '1999-01-14', '1999-01-15', '1999-01-18', '1999-01-19', '1999-01-20', '1999-01-21', '1999-01-22', '1999-01-25', '1999-01-26', '1999-01-27', '1999-01-28', '1999-01-29', '1999-02-01', '1999-02-02', '1999-02-03', '1999-02-04', '1999-02-05', '1999-02-08', '1999-02-09', '1999-03-01', '1999-03-02', '1999-03-03', '1999-03-04', '1999-03-05', '1999-03-08', '1999-03-09', '1999-03-10', '1999-03-11', '1999-03-12', '1999-03-15', '1999-03-16', '1999-03-17', '1999-03-18', '1999-03-19', '1999-03-22', '1999-03-23', '1999-03-24', '1999-03-25', '1999-03-26', '1999-03-29', '1999-03-30', '1999-03-31', '1999-04-01', '1999-04-02', '1999-04-05', '1999-04-06', '1999-04-07', '1999-04-08', '1999-04-09', '1999-04-12', '1999-04-13', '1999-04-14', '1999-04-15', '1999-04-16', '1999-04-19', '1999-04-20', '1999-04-21', '1999-04-22', '1999-04-23', '1999-04-26', '1999-04-27', '1999-04-28', '1999-04-29', '1999-04-30', '1999-05-04', '1999-05-05', '1999-05-06', '1999-05-07', '1999-05-10', '1999-05-11', '1999-05-12', '1999-05-13', '1999-05-14', '1999-05-17', '1999-05-18', '1999-05-19', '1999-05-20', '1999-05-21', '1999-05-24', '1999-05-25', '1999-05-26', '1999-05-27', '1999-05-28', '1999-05-31', '1999-06-01', '1999-06-02', '1999-06-03', '1999-06-04', '1999-06-07', '1999-06-08', '1999-06-09', '1999-06-10', '1999-06-11', '1999-06-14', '1999-06-15', '1999-06-16', '1999-06-17', '1999-06-18', '1999-06-21', '1999-06-22', '1999-06-23', '1999-06-24', '1999-06-25', '1999-06-28', '1999-06-29', '1999-06-30', '1999-07-01', '1999-07-02', '1999-07-05', '1999-07-06', '1999-07-07', '1999-07-08', '1999-07-09', '1999-07-12', '1999-07-13', '1999-07-14', '1999-07-15', '1999-07-16', '1999-07-19', '1999-07-20', '1999-07-21', '1999-07-22', '1999-07-23', '1999-07-26', '1999-07-27', '1999-07-28', '1999-07-29', '1999-07-30', '1999-08-02', '1999-08-03', '1999-08-04', '1999-08-05', '1999-08-06', '1999-08-09', '1999-08-10', '1999-08-11', '1999-08-12', '1999-08-13', '1999-08-16', '1999-08-17', '1999-08-18', '1999-08-19', '1999-08-20', '1999-08-23', '1999-08-24', '1999-08-25', '1999-08-26', '1999-08-27', '1999-08-30', '1999-08-31', '1999-09-01', '1999-09-02', '1999-09-03', '1999-09-06', '1999-09-07', '1999-09-08', '1999-09-09', '1999-09-10', '1999-09-13', '1999-09-14', '1999-09-15', '1999-09-16', '1999-09-17', '1999-09-20', '1999-09-21', '1999-09-22', '1999-09-23', '1999-09-24', '1999-09-27', '1999-09-28', '1999-09-29', '1999-09-30', '1999-10-08', '1999-10-11', '1999-10-12', '1999-10-13', '1999-10-14', '1999-10-15', '1999-10-18', '1999-10-19', '1999-10-20', '1999-10-21', '1999-10-22', '1999-10-25', '1999-10-26', '1999-10-27', '1999-10-28', '1999-10-29', '1999-11-01', '1999-11-02', '1999-11-03', '1999-11-04', '1999-11-05', '1999-11-08', '1999-11-09', '1999-11-10', '1999-11-11', '1999-11-12', '1999-11-15', '1999-11-16', '1999-11-17', '1999-11-18', '1999-11-19', '1999-11-22', '1999-11-23', '1999-11-24', '1999-11-25', '1999-11-26', '1999-11-29', '1999-11-30', '1999-12-01', '1999-12-02', '1999-12-03', '1999-12-06', '1999-12-07', '1999-12-08', '1999-12-09', '1999-12-10', '1999-12-13', '1999-12-14', '1999-12-15', '1999-12-16', '1999-12-17', '1999-12-21', '1999-12-22', '1999-12-23', '1999-12-24', '1999-12-27', '1999-12-28', '1999-12-29', '1999-12-30', '2000-01-04', '2000-01-05', '2000-01-06', '2000-01-07', '2000-01-10', '2000-01-11', '2000-01-12', '2000-01-13', '2000-01-14', '2000-01-17', '2000-01-18', '2000-01-19', '2000-01-20', '2000-01-21', '2000-01-24', '2000-01-25', '2000-01-26', '2000-01-27', '2000-01-28', '2000-02-14', '2000-02-15', '2000-02-16', '2000-02-17', '2000-02-18', '2000-02-21', '2000-02-22', '2000-02-23', '2000-02-24', '2000-02-25', '2000-02-28', '2000-02-29', '2000-03-01', '2000-03-02', '2000-03-03', '2000-03-06', '2000-03-07', '2000-03-08', '2000-03-09', '2000-03-10', '2000-03-13', '2000-03-14', '2000-03-15', '2000-03-16', '2000-03-17', '2000-03-20', '2000-03-21', '2000-03-22', '2000-03-23', '2000-03-24', '2000-03-27', '2000-03-28', '2000-03-29', '2000-03-30', '2000-03-31', '2000-04-03', '2000-04-04', '2000-04-05', '2000-04-06', '2000-04-07', '2000-04-10', '2000-04-11', '2000-04-12', '2000-04-13', '2000-04-14', '2000-04-17', '2000-04-18', '2000-04-19', '2000-04-20', '2000-04-21', '2000-04-24', '2000-04-25', '2000-04-26', '2000-04-27', '2000-04-28', '2000-05-08', '2000-05-09', '2000-05-10', '2000-05-11', '2000-05-12', '2000-05-15', '2000-05-16', '2000-05-17', '2000-05-18', '2000-05-19', '2000-05-22', '2000-05-23', '2000-05-24', '2000-05-25', '2000-05-26', '2000-05-29', '2000-05-30', '2000-05-31', '2000-06-01', '2000-06-02', '2000-06-05', '2000-06-06', '2000-06-07', '2000-06-08', '2000-06-09', '2000-06-12', '2000-06-13', '2000-06-14', '2000-06-15', '2000-06-16', '2000-06-19', '2000-06-20', '2000-06-21', '2000-06-22', '2000-06-23', '2000-06-26', '2000-06-27', '2000-06-28', '2000-06-29', '2000-06-30', '2000-07-03', '2000-07-04', '2000-07-05', '2000-07-06', '2000-07-07', '2000-07-10', '2000-07-11', '2000-07-12', '2000-07-13', '2000-07-14', '2000-07-17', '2000-07-18', '2000-07-19', '2000-07-20', '2000-07-21', '2000-07-24', '2000-07-25', '2000-07-26', '2000-07-27', '2000-07-28', '2000-07-31', '2000-08-01', '2000-08-02', '2000-08-03', '2000-08-04', '2000-08-07', '2000-08-08', '2000-08-09', '2000-08-10', '2000-08-11', '2000-08-14', '2000-08-15', '2000-08-16', '2000-08-17', '2000-08-18', '2000-08-21', '2000-08-22', '2000-08-23', '2000-08-24', '2000-08-25', '2000-08-28', '2000-08-29', '2000-08-30', '2000-08-31', '2000-09-01', '2000-09-04', '2000-09-05', '2000-09-06', '2000-09-07', '2000-09-08', '2000-09-11', '2000-09-12', '2000-09-13', '2000-09-14', '2000-09-15', '2000-09-18', '2000-09-19', '2000-09-20', '2000-09-21', '2000-09-22', '2000-09-25', '2000-09-26', '2000-09-27', '2000-09-28', '2000-09-29', '2000-10-09', '2000-10-10', '2000-10-11', '2000-10-12', '2000-10-13', '2000-10-16', '2000-10-17', '2000-10-18', '2000-10-19', '2000-10-20', '2000-10-23', '2000-10-24', '2000-10-25', '2000-10-26', '2000-10-27', '2000-10-30', '2000-10-31', '2000-11-01', '2000-11-02', '2000-11-03', '2000-11-06', '2000-11-07', '2000-11-08', '2000-11-09', '2000-11-10', '2000-11-13', '2000-11-14', '2000-11-15', '2000-11-16', '2000-11-17', '2000-11-20', '2000-11-21', '2000-11-22', '2000-11-23', '2000-11-24', '2000-11-27', '2000-11-28', '2000-11-29', '2000-11-30', '2000-12-01', '2000-12-04', '2000-12-05', '2000-12-06', '2000-12-07', '2000-12-08', '2000-12-11', '2000-12-12', '2000-12-13', '2000-12-14', '2000-12-15', '2000-12-18', '2000-12-19', '2000-12-20', '2000-12-21', '2000-12-22', '2000-12-25', '2000-12-26', '2000-12-27', '2000-12-28', '2000-12-29', '2001-01-02', '2001-01-03', '2001-01-04', '2001-01-05', '2001-01-08', '2001-01-09', '2001-01-10', '2001-01-11', '2001-01-12', '2001-01-15', '2001-01-16', '2001-01-17', '2001-01-18', '2001-01-19', '2001-02-05', '2001-02-06', '2001-02-07', '2001-02-08', '2001-02-09', '2001-02-12', '2001-02-13', '2001-02-14', '2001-02-15', '2001-02-16', '2001-02-19', '2001-02-20', '2001-02-21', '2001-02-22', '2001-02-23', '2001-02-26', '2001-02-27', '2001-02-28', '2001-03-01', '2001-03-02', '2001-03-05', '2001-03-06', '2001-03-07', '2001-03-08', '2001-03-09', '2001-03-12', '2001-03-13', '2001-03-14', '2001-03-15', '2001-03-16', '2001-03-19', '2001-03-20', '2001-03-21', '2001-03-22', '2001-03-23', '2001-03-26', '2001-03-27', '2001-03-28', '2001-03-29', '2001-03-30', '2001-04-02', '2001-04-03', '2001-04-04', '2001-04-05', '2001-04-06', '2001-04-09', '2001-04-10', '2001-04-11', '2001-04-12', '2001-04-13', '2001-04-16', '2001-04-17', '2001-04-18', '2001-04-19', '2001-04-20', '2001-04-23', '2001-04-24', '2001-04-25', '2001-04-26', '2001-04-27', '2001-04-30', '2001-05-08', '2001-05-09', '2001-05-10', '2001-05-11', '2001-05-14', '2001-05-15', '2001-05-16', '2001-05-17', '2001-05-18', '2001-05-21', '2001-05-22', '2001-05-23', '2001-05-24', '2001-05-25', '2001-05-28', '2001-05-29', '2001-05-30', '2001-05-31', '2001-06-01', '2001-06-04', '2001-06-05', '2001-06-06', '2001-06-07', '2001-06-08', '2001-06-11', '2001-06-12', '2001-06-13', '2001-06-14', '2001-06-15', '2001-06-18', '2001-06-19', '2001-06-20', '2001-06-21', '2001-06-22', '2001-06-25', '2001-06-26', '2001-06-27', '2001-06-28', '2001-06-29', '2001-07-02', '2001-07-03', '2001-07-04', '2001-07-05', '2001-07-06', '2001-07-09', '2001-07-10', '2001-07-11', '2001-07-12', '2001-07-13', '2001-07-16', '2001-07-17', '2001-07-18', '2001-07-19', '2001-07-20', '2001-07-23', '2001-07-24', '2001-07-25', '2001-07-26', '2001-07-27', '2001-07-30', '2001-07-31', '2001-08-01', '2001-08-02', '2001-08-03', '2001-08-06', '2001-08-07', '2001-08-08', '2001-08-09', '2001-08-10', '2001-08-13', '2001-08-14', '2001-08-15', '2001-08-16', '2001-08-17', '2001-08-20', '2001-08-21', '2001-08-22', '2001-08-23', '2001-08-24', '2001-08-27', '2001-08-28', '2001-08-29', '2001-08-30', '2001-08-31', '2001-09-03', '2001-09-04', '2001-09-05', '2001-09-06', '2001-09-07', '2001-09-10', '2001-09-11', '2001-09-12', '2001-09-13', '2001-09-14', '2001-09-17', '2001-09-18', '2001-09-19', '2001-09-20', '2001-09-21', '2001-09-24', '2001-09-25', '2001-09-26', '2001-09-27', '2001-09-28', '2001-10-08', '2001-10-09', '2001-10-10', '2001-10-11', '2001-10-12', '2001-10-15', '2001-10-16', '2001-10-17', '2001-10-18', '2001-10-19', '2001-10-22', '2001-10-23', '2001-10-24', '2001-10-25', '2001-10-26', '2001-10-29', '2001-10-30', '2001-10-31', '2001-11-01', '2001-11-02', '2001-11-05', '2001-11-06', '2001-11-07', '2001-11-08', '2001-11-09', '2001-11-12', '2001-11-13', '2001-11-14', '2001-11-15', '2001-11-16', '2001-11-19', '2001-11-20', '2001-11-21', '2001-11-22', '2001-11-23', '2001-11-26', '2001-11-27', '2001-11-28', '2001-11-29', '2001-11-30', '2001-12-03', '2001-12-04', '2001-12-05', '2001-12-06', '2001-12-07', '2001-12-10', '2001-12-11', '2001-12-12', '2001-12-13', '2001-12-14', '2001-12-17', '2001-12-18', '2001-12-19', '2001-12-20', '2001-12-21', '2001-12-24', '2001-12-25', '2001-12-26', '2001-12-27', '2001-12-28', '2001-12-31', '2002-01-04', '2002-01-07', '2002-01-08', '2002-01-09', '2002-01-10', '2002-01-11', '2002-01-14', '2002-01-15', '2002-01-16', '2002-01-17', '2002-01-18', '2002-01-21', '2002-01-22', '2002-01-23', '2002-01-24', '2002-01-25', '2002-01-28', '2002-01-29', '2002-01-30', '2002-01-31', '2002-02-01', '2002-02-04', '2002-02-05', '2002-02-06', '2002-02-07', '2002-02-08', '2002-02-25', '2002-02-26', '2002-02-27', '2002-02-28', '2002-03-01', '2002-03-04', '2002-03-05', '2002-03-06', '2002-03-07', '2002-03-08', '2002-03-11', '2002-03-12', '2002-03-13', '2002-03-14', '2002-03-15', '2002-03-18', '2002-03-19', '2002-03-20', '2002-03-21', '2002-03-22', '2002-03-25', '2002-03-26', '2002-03-27', '2002-03-28', '2002-03-29', '2002-04-01', '2002-04-02', '2002-04-03', '2002-04-04', '2002-04-05', '2002-04-08', '2002-04-09', '2002-04-10', '2002-04-11', '2002-04-12', '2002-04-15', '2002-04-16', '2002-04-17', '2002-04-18', '2002-04-19', '2002-04-22', '2002-04-23', '2002-04-24', '2002-04-25', '2002-04-26', '2002-04-29', '2002-04-30', '2002-05-08', '2002-05-09', '2002-05-10', '2002-05-13', '2002-05-14', '2002-05-15', '2002-05-16', '2002-05-17', '2002-05-20', '2002-05-21', '2002-05-22', '2002-05-23', '2002-05-24', '2002-05-27', '2002-05-28', '2002-05-29', '2002-05-30', '2002-05-31', '2002-06-03', '2002-06-04', '2002-06-05', '2002-06-06', '2002-06-07', '2002-06-10', '2002-06-11', '2002-06-12', '2002-06-13', '2002-06-14', '2002-06-17', '2002-06-18', '2002-06-19', '2002-06-20', '2002-06-21', '2002-06-24', '2002-06-25', '2002-06-26', '2002-06-27', '2002-06-28', '2002-07-01', '2002-07-02', '2002-07-03', '2002-07-04', '2002-07-05', '2002-07-08', '2002-07-09', '2002-07-10', '2002-07-11', '2002-07-12', '2002-07-15', '2002-07-16', '2002-07-17', '2002-07-18', '2002-07-19', '2002-07-22', '2002-07-23', '2002-07-24', '2002-07-25', '2002-07-26', '2002-07-29', '2002-07-30', '2002-07-31', '2002-08-01', '2002-08-02', '2002-08-05', '2002-08-06', '2002-08-07', '2002-08-08', '2002-08-09', '2002-08-12', '2002-08-13', '2002-08-14', '2002-08-15', '2002-08-16', '2002-08-19', '2002-08-20', '2002-08-21', '2002-08-22', '2002-08-23', '2002-08-26', '2002-08-27', '2002-08-28', '2002-08-29', '2002-08-30', '2002-09-02', '2002-09-03', '2002-09-04', '2002-09-05', '2002-09-06', '2002-09-09', '2002-09-10', '2002-09-11', '2002-09-12', '2002-09-13', '2002-09-16', '2002-09-17', '2002-09-18', '2002-09-19', '2002-09-20', '2002-09-23', '2002-09-24', '2002-09-25', '2002-09-26', '2002-09-27', '2002-10-08', '2002-10-09', '2002-10-10', '2002-10-11', '2002-10-14', '2002-10-15', '2002-10-16', '2002-10-17', '2002-10-18', '2002-10-21', '2002-10-22', '2002-10-23', '2002-10-24', '2002-10-25', '2002-10-28', '2002-10-29', '2002-10-30', '2002-10-31', '2002-11-01', '2002-11-04', '2002-11-05', '2002-11-06', '2002-11-07', '2002-11-08', '2002-11-11', '2002-11-12', '2002-11-13', '2002-11-14', '2002-11-15', '2002-11-18', '2002-11-19', '2002-11-20', '2002-11-21', '2002-11-22', '2002-11-25', '2002-11-26', '2002-11-27', '2002-11-28', '2002-11-29', '2002-12-02', '2002-12-03', '2002-12-04', '2002-12-05', '2002-12-06', '2002-12-09', '2002-12-10', '2002-12-11', '2002-12-12', '2002-12-13', '2002-12-16', '2002-12-17', '2002-12-18', '2002-12-19', '2002-12-20', '2002-12-23', '2002-12-24', '2002-12-25', '2002-12-26', '2002-12-27', '2002-12-30', '2002-12-31', '2003-01-02', '2003-01-03', '2003-01-06', '2003-01-07', '2003-01-08', '2003-01-09', '2003-01-10', '2003-01-13', '2003-01-14', '2003-01-15', '2003-01-16', '2003-01-17', '2003-01-20', '2003-01-21', '2003-01-22', '2003-01-23', '2003-01-24', '2003-01-27', '2003-01-28', '2003-01-29', '2003-02-10', '2003-02-11', '2003-02-12', '2003-02-13', '2003-02-14', '2003-02-17', '2003-02-18', '2003-02-19', '2003-02-20', '2003-02-21', '2003-02-24', '2003-02-25', '2003-02-26', '2003-02-27', '2003-02-28', '2003-03-03', '2003-03-04', '2003-03-05', '2003-03-06', '2003-03-07', '2003-03-10', '2003-03-11', '2003-03-12', '2003-03-13', '2003-03-14', '2003-03-17', '2003-03-18', '2003-03-19', '2003-03-20', '2003-03-21', '2003-03-24', '2003-03-25', '2003-03-26', '2003-03-27', '2003-03-28', '2003-03-31', '2003-04-01', '2003-04-02', '2003-04-03', '2003-04-04', '2003-04-07', '2003-04-08', '2003-04-09', '2003-04-10', '2003-04-11', '2003-04-14', '2003-04-15', '2003-04-16', '2003-04-17', '2003-04-18', '2003-04-21', '2003-04-22', '2003-04-23', '2003-04-24', '2003-04-25', '2003-04-28', '2003-04-29', '2003-04-30', '2003-05-12', '2003-05-13', '2003-05-14', '2003-05-15', '2003-05-16', '2003-05-19', '2003-05-20', '2003-05-21', '2003-05-22', '2003-05-23', '2003-05-26', '2003-05-27', '2003-05-28', '2003-05-29', '2003-05-30', '2003-06-02', '2003-06-03', '2003-06-04', '2003-06-05', '2003-06-06', '2003-06-09', '2003-06-10', '2003-06-11', '2003-06-12', '2003-06-13', '2003-06-16', '2003-06-17', '2003-06-18', '2003-06-19', '2003-06-20', '2003-06-23', '2003-06-24', '2003-06-25', '2003-06-26', '2003-06-27', '2003-06-30', '2003-07-01', '2003-07-02', '2003-07-03', '2003-07-04', '2003-07-07', '2003-07-08', '2003-07-09', '2003-07-10', '2003-07-11', '2003-07-14', '2003-07-15', '2003-07-16', '2003-07-17', '2003-07-18', '2003-07-21', '2003-07-22', '2003-07-23', '2003-07-24', '2003-07-25', '2003-07-28', '2003-07-29', '2003-07-30', '2003-07-31', '2003-08-01', '2003-08-04', '2003-08-05', '2003-08-06', '2003-08-07', '2003-08-08', '2003-08-11', '2003-08-12', '2003-08-13', '2003-08-14', '2003-08-15', '2003-08-18', '2003-08-19', '2003-08-20', '2003-08-21', '2003-08-22', '2003-08-25', '2003-08-26', '2003-08-27', '2003-08-28', '2003-08-29', '2003-09-01', '2003-09-02', '2003-09-03', '2003-09-04', '2003-09-05', '2003-09-08', '2003-09-09', '2003-09-10', '2003-09-11', '2003-09-12', '2003-09-15', '2003-09-16', '2003-09-17', '2003-09-18', '2003-09-19', '2003-09-22', '2003-09-23', '2003-09-24', '2003-09-25', '2003-09-26', '2003-09-29', '2003-09-30', '2003-10-08', '2003-10-09', '2003-10-10', '2003-10-13', '2003-10-14', '2003-10-15', '2003-10-16', '2003-10-17', '2003-10-20', '2003-10-21', '2003-10-22', '2003-10-23', '2003-10-24', '2003-10-27', '2003-10-28', '2003-10-29', '2003-10-30', '2003-10-31', '2003-11-03', '2003-11-04', '2003-11-05', '2003-11-06', '2003-11-07', '2003-11-10', '2003-11-11', '2003-11-12', '2003-11-13', '2003-11-14', '2003-11-17', '2003-11-18', '2003-11-19', '2003-11-20', '2003-11-21', '2003-11-24', '2003-11-25', '2003-11-26', '2003-11-27', '2003-11-28', '2003-12-01', '2003-12-02', '2003-12-03', '2003-12-04', '2003-12-05', '2003-12-08', '2003-12-09', '2003-12-10', '2003-12-11', '2003-12-12', '2003-12-15', '2003-12-16', '2003-12-17', '2003-12-18', '2003-12-19', '2003-12-22', '2003-12-23', '2003-12-24', '2003-12-25', '2003-12-26', '2003-12-29', '2003-12-30', '2003-12-31', '2004-01-02', '2004-01-05', '2004-01-06', '2004-01-07', '2004-01-08', '2004-01-09', '2004-01-12', '2004-01-13', '2004-01-14', '2004-01-15', '2004-01-16', '2004-01-29', '2004-01-30', '2004-02-02', '2004-02-03', '2004-02-04', '2004-02-05', '2004-02-06', '2004-02-09', '2004-02-10', '2004-02-11', '2004-02-12', '2004-02-13', '2004-02-16', '2004-02-17', '2004-02-18', '2004-02-19', '2004-02-20', '2004-02-23', '2004-02-24', '2004-02-25', '2004-02-26', '2004-02-27', '2004-03-01', '2004-03-02', '2004-03-03', '2004-03-04', '2004-03-05', '2004-03-08', '2004-03-09', '2004-03-10', '2004-03-11', '2004-03-12', '2004-03-15', '2004-03-16', '2004-03-17', '2004-03-18', '2004-03-19', '2004-03-22', '2004-03-23', '2004-03-24', '2004-03-25', '2004-03-26', '2004-03-29', '2004-03-30', '2004-03-31', '2004-04-01', '2004-04-02', '2004-04-05', '2004-04-06', '2004-04-07', '2004-04-08', '2004-04-09', '2004-04-12', '2004-04-13', '2004-04-14', '2004-04-15', '2004-04-16', '2004-04-19', '2004-04-20', '2004-04-21', '2004-04-22', '2004-04-23', '2004-04-26', '2004-04-27', '2004-04-28', '2004-04-29', '2004-04-30', '2004-05-10', '2004-05-11', '2004-05-12', '2004-05-13', '2004-05-14', '2004-05-17', '2004-05-18', '2004-05-19', '2004-05-20', '2004-05-21', '2004-05-24', '2004-05-25', '2004-05-26', '2004-05-27', '2004-05-28', '2004-05-31', '2004-06-01', '2004-06-02', '2004-06-03', '2004-06-04', '2004-06-07', '2004-06-08', '2004-06-09', '2004-06-10', '2004-06-11', '2004-06-14', '2004-06-15', '2004-06-16', '2004-06-17', '2004-06-18', '2004-06-21', '2004-06-22', '2004-06-23', '2004-06-24', '2004-06-25', '2004-06-28', '2004-06-29', '2004-06-30', '2004-07-01', '2004-07-02', '2004-07-05', '2004-07-06', '2004-07-07', '2004-07-08', '2004-07-09', '2004-07-12', '2004-07-13', '2004-07-14', '2004-07-15', '2004-07-16', '2004-07-19', '2004-07-20', '2004-07-21', '2004-07-22', '2004-07-23', '2004-07-26', '2004-07-27', '2004-07-28', '2004-07-29', '2004-07-30', '2004-08-02', '2004-08-03', '2004-08-04', '2004-08-05', '2004-08-06', '2004-08-09', '2004-08-10', '2004-08-11', '2004-08-12', '2004-08-13', '2004-08-16', '2004-08-17', '2004-08-18', '2004-08-19', '2004-08-20', '2004-08-23', '2004-08-24', '2004-08-25', '2004-08-26', '2004-08-27', '2004-08-30', '2004-08-31', '2004-09-01', '2004-09-02', '2004-09-03', '2004-09-06', '2004-09-07', '2004-09-08', '2004-09-09', '2004-09-10', '2004-09-13', '2004-09-14', '2004-09-15', '2004-09-16', '2004-09-17', '2004-09-20', '2004-09-21', '2004-09-22', '2004-09-23', '2004-09-24', '2004-09-27', '2004-09-28', '2004-09-29', '2004-09-30', '2004-10-08', '2004-10-11', '2004-10-12', '2004-10-13', '2004-10-14', '2004-10-15', '2004-10-18', '2004-10-19', '2004-10-20', '2004-10-21', '2004-10-22', '2004-10-25', '2004-10-26', '2004-10-27', '2004-10-28', '2004-10-29', '2004-11-01', '2004-11-02', '2004-11-03', '2004-11-04', '2004-11-05', '2004-11-08', '2004-11-09', '2004-11-10', '2004-11-11', '2004-11-12', '2004-11-15', '2004-11-16', '2004-11-17', '2004-11-18', '2004-11-19', '2004-11-22', '2004-11-23', '2004-11-24', '2004-11-25', '2004-11-26', '2004-11-29', '2004-11-30', '2004-12-01', '2004-12-02', '2004-12-03', '2004-12-06', '2004-12-07', '2004-12-08', '2004-12-09', '2004-12-10', '2004-12-13', '2004-12-14', '2004-12-15', '2004-12-16', '2004-12-17', '2004-12-20', '2004-12-21', '2004-12-22', '2004-12-23', '2004-12-24', '2004-12-27', '2004-12-28', '2004-12-29', '2004-12-30', '2004-12-31', '2005-01-04', '2005-01-05', '2005-01-06', '2005-01-07', '2005-01-10', '2005-01-11', '2005-01-12', '2005-01-13', '2005-01-14', '2005-01-17', '2005-01-18', '2005-01-19', '2005-01-20', '2005-01-21', '2005-01-24', '2005-01-25', '2005-01-26', '2005-01-27', '2005-01-28', '2005-01-31', '2005-02-01', '2005-02-02', '2005-02-03', '2005-02-04', '2005-02-16', '2005-02-17', '2005-02-18', '2005-02-21', '2005-02-22', '2005-02-23', '2005-02-24', '2005-02-25', '2005-02-28', '2005-03-01', '2005-03-02', '2005-03-03', '2005-03-04', '2005-03-07', '2005-03-08', '2005-03-09', '2005-03-10', '2005-03-11', '2005-03-14', '2005-03-15', '2005-03-16', '2005-03-17', '2005-03-18', '2005-03-21', '2005-03-22', '2005-03-23', '2005-03-24', '2005-03-25', '2005-03-28', '2005-03-29', '2005-03-30', '2005-03-31', '2005-04-01', '2005-04-04', '2005-04-05', '2005-04-06', '2005-04-07', '2005-04-08', '2005-04-11', '2005-04-12', '2005-04-13', '2005-04-14', '2005-04-15', '2005-04-18', '2005-04-19', '2005-04-20', '2005-04-21', '2005-04-22', '2005-04-25', '2005-04-26', '2005-04-27', '2005-04-28', '2005-04-29', '2005-05-09', '2005-05-10', '2005-05-11', '2005-05-12', '2005-05-13', '2005-05-16', '2005-05-17', '2005-05-18', '2005-05-19', '2005-05-20', '2005-05-23', '2005-05-24', '2005-05-25', '2005-05-26', '2005-05-27', '2005-05-30', '2005-05-31', '2005-06-01', '2005-06-02', '2005-06-03', '2005-06-06', '2005-06-07', '2005-06-08', '2005-06-09', '2005-06-10', '2005-06-13', '2005-06-14', '2005-06-15', '2005-06-16', '2005-06-17', '2005-06-20', '2005-06-21', '2005-06-22', '2005-06-23', '2005-06-24', '2005-06-27', '2005-06-28', '2005-06-29', '2005-06-30', '2005-07-01', '2005-07-04', '2005-07-05', '2005-07-06', '2005-07-07', '2005-07-08', '2005-07-11', '2005-07-12', '2005-07-13', '2005-07-14', '2005-07-15', '2005-07-18', '2005-07-19', '2005-07-20', '2005-07-21', '2005-07-22', '2005-07-25', '2005-07-26', '2005-07-27', '2005-07-28', '2005-07-29', '2005-08-01', '2005-08-02', '2005-08-03', '2005-08-04', '2005-08-05', '2005-08-08', '2005-08-09', '2005-08-10', '2005-08-11', '2005-08-12', '2005-08-15', '2005-08-16', '2005-08-17', '2005-08-18', '2005-08-19', '2005-08-22', '2005-08-23', '2005-08-24', '2005-08-25', '2005-08-26', '2005-08-29', '2005-08-30', '2005-08-31', '2005-09-01', '2005-09-02', '2005-09-05', '2005-09-06', '2005-09-07', '2005-09-08', '2005-09-09', '2005-09-12', '2005-09-13', '2005-09-14', '2005-09-15', '2005-09-16', '2005-09-19', '2005-09-20', '2005-09-21', '2005-09-22', '2005-09-23', '2005-09-26', '2005-09-27', '2005-09-28', '2005-09-29', '2005-09-30', '2005-10-10', '2005-10-11', '2005-10-12', '2005-10-13', '2005-10-14', '2005-10-17', '2005-10-18', '2005-10-19', '2005-10-20', '2005-10-21', '2005-10-24', '2005-10-25', '2005-10-26', '2005-10-27', '2005-10-28', '2005-10-31', '2005-11-01', '2005-11-02', '2005-11-03', '2005-11-04', '2005-11-07', '2005-11-08', '2005-11-09', '2005-11-10', '2005-11-11', '2005-11-14', '2005-11-15', '2005-11-16', '2005-11-17', '2005-11-18', '2005-11-21', '2005-11-22', '2005-11-23', '2005-11-24', '2005-11-25', '2005-11-28', '2005-11-29', '2005-11-30', '2005-12-01', '2005-12-02', '2005-12-05', '2005-12-06', '2005-12-07', '2005-12-08', '2005-12-09', '2005-12-12', '2005-12-13', '2005-12-14', '2005-12-15', '2005-12-16', '2005-12-19', '2005-12-20', '2005-12-21', '2005-12-22', '2005-12-23', '2005-12-26', '2005-12-27', '2005-12-28', '2005-12-29', '2005-12-30', '2006-01-04', '2006-01-05', '2006-01-06', '2006-01-09', '2006-01-10', '2006-01-11', '2006-01-12', '2006-01-13', '2006-01-16', '2006-01-17', '2006-01-18', '2006-01-19', '2006-01-20', '2006-01-23', '2006-01-24', '2006-01-25', '2006-02-06', '2006-02-07', '2006-02-08', '2006-02-09', '2006-02-10', '2006-02-13', '2006-02-14', '2006-02-15', '2006-02-16', '2006-02-17', '2006-02-20', '2006-02-21', '2006-02-22', '2006-02-23', '2006-02-24', '2006-02-27', '2006-02-28', '2006-03-01', '2006-03-02', '2006-03-03', '2006-03-06', '2006-03-07', '2006-03-08', '2006-03-09', '2006-03-10', '2006-03-13', '2006-03-14', '2006-03-15', '2006-03-16', '2006-03-17', '2006-03-20', '2006-03-21', '2006-03-22', '2006-03-23', '2006-03-24', '2006-03-27', '2006-03-28', '2006-03-29', '2006-03-30', '2006-03-31', '2006-04-03', '2006-04-04', '2006-04-05', '2006-04-06', '2006-04-07', '2006-04-10', '2006-04-11', '2006-04-12', '2006-04-13', '2006-04-14', '2006-04-17', '2006-04-18', '2006-04-19', '2006-04-20', '2006-04-21', '2006-04-24', '2006-04-25', '2006-04-26', '2006-04-27', '2006-04-28', '2006-05-08', '2006-05-09', '2006-05-10', '2006-05-11', '2006-05-12', '2006-05-15', '2006-05-16', '2006-05-17', '2006-05-18', '2006-05-19', '2006-05-22', '2006-05-23', '2006-05-24', '2006-05-25', '2006-05-26', '2006-05-29', '2006-05-30', '2006-05-31', '2006-06-01', '2006-06-02', '2006-06-05', '2006-06-06', '2006-06-07', '2006-06-08', '2006-06-09', '2006-06-12', '2006-06-13', '2006-06-14', '2006-06-15', '2006-06-16', '2006-06-19', '2006-06-20', '2006-06-21', '2006-06-22', '2006-06-23', '2006-06-26', '2006-06-27', '2006-06-28', '2006-06-29', '2006-06-30', '2006-07-03', '2006-07-04', '2006-07-05', '2006-07-06', '2006-07-07', '2006-07-10', '2006-07-11', '2006-07-12', '2006-07-13', '2006-07-14', '2006-07-17', '2006-07-18', '2006-07-19', '2006-07-20', '2006-07-21', '2006-07-24', '2006-07-25', '2006-07-26', '2006-07-27', '2006-07-28', '2006-07-31', '2006-08-01', '2006-08-02', '2006-08-03', '2006-08-04', '2006-08-07', '2006-08-08', '2006-08-09', '2006-08-10', '2006-08-11', '2006-08-14', '2006-08-15', '2006-08-16', '2006-08-17', '2006-08-18', '2006-08-21', '2006-08-22', '2006-08-23', '2006-08-24', '2006-08-25', '2006-08-28', '2006-08-29', '2006-08-30', '2006-08-31', '2006-09-01', '2006-09-04', '2006-09-05', '2006-09-06', '2006-09-07', '2006-09-08', '2006-09-11', '2006-09-12', '2006-09-13', '2006-09-14', '2006-09-15', '2006-09-18', '2006-09-19', '2006-09-20', '2006-09-21', '2006-09-22', '2006-09-25', '2006-09-26', '2006-09-27', '2006-09-28', '2006-09-29', '2006-10-09', '2006-10-10', '2006-10-11', '2006-10-12', '2006-10-13', '2006-10-16', '2006-10-17', '2006-10-18', '2006-10-19', '2006-10-20', '2006-10-23', '2006-10-24', '2006-10-25', '2006-10-26', '2006-10-27', '2006-10-30', '2006-10-31', '2006-11-01', '2006-11-02', '2006-11-03', '2006-11-06', '2006-11-07', '2006-11-08', '2006-11-09', '2006-11-10', '2006-11-13', '2006-11-14', '2006-11-15', '2006-11-16', '2006-11-17', '2006-11-20', '2006-11-21', '2006-11-22', '2006-11-23', '2006-11-24', '2006-11-27', '2006-11-28', '2006-11-29', '2006-11-30', '2006-12-01', '2006-12-04', '2006-12-05', '2006-12-06', '2006-12-07', '2006-12-08', '2006-12-11', '2006-12-12', '2006-12-13', '2006-12-14', '2006-12-15', '2006-12-18', '2006-12-19', '2006-12-20', '2006-12-21', '2006-12-22', '2006-12-25', '2006-12-26', '2006-12-27', '2006-12-28', '2006-12-29', '2007-01-04', '2007-01-05', '2007-01-08', '2007-01-09', '2007-01-10', '2007-01-11', '2007-01-12', '2007-01-15', '2007-01-16', '2007-01-17', '2007-01-18', '2007-01-19', '2007-01-22', '2007-01-23', '2007-01-24', '2007-01-25', '2007-01-26', '2007-01-29', '2007-01-30', '2007-01-31', '2007-02-01', '2007-02-02', '2007-02-05', '2007-02-06', '2007-02-07', '2007-02-08', '2007-02-09', '2007-02-12', '2007-02-13', '2007-02-14', '2007-02-15', '2007-02-16', '2007-02-26', '2007-02-27', '2007-02-28', '2007-03-01', '2007-03-02', '2007-03-05', '2007-03-06', '2007-03-07', '2007-03-08', '2007-03-09', '2007-03-12', '2007-03-13', '2007-03-14', '2007-03-15', '2007-03-16', '2007-03-19', '2007-03-20', '2007-03-21', '2007-03-22', '2007-03-23', '2007-03-26', '2007-03-27', '2007-03-28', '2007-03-29', '2007-03-30', '2007-04-02', '2007-04-03', '2007-04-04', '2007-04-05', '2007-04-06', '2007-04-09', '2007-04-10', '2007-04-11', '2007-04-12', '2007-04-13', '2007-04-16', '2007-04-17', '2007-04-18', '2007-04-19', '2007-04-20', '2007-04-23', '2007-04-24', '2007-04-25', '2007-04-26', '2007-04-27', '2007-04-30', '2007-05-08', '2007-05-09', '2007-05-10', '2007-05-11', '2007-05-14', '2007-05-15', '2007-05-16', '2007-05-17', '2007-05-18', '2007-05-21', '2007-05-22', '2007-05-23', '2007-05-24', '2007-05-25', '2007-05-28', '2007-05-29', '2007-05-30', '2007-05-31', '2007-06-01', '2007-06-04', '2007-06-05', '2007-06-06', '2007-06-07', '2007-06-08', '2007-06-11', '2007-06-12', '2007-06-13', '2007-06-14', '2007-06-15', '2007-06-18', '2007-06-19', '2007-06-20', '2007-06-21', '2007-06-22', '2007-06-25', '2007-06-26', '2007-06-27', '2007-06-28', '2007-06-29', '2007-07-02', '2007-07-03', '2007-07-04', '2007-07-05', '2007-07-06', '2007-07-09', '2007-07-10', '2007-07-11', '2007-07-12', '2007-07-13', '2007-07-16', '2007-07-17', '2007-07-18', '2007-07-19', '2007-07-20', '2007-07-23', '2007-07-24', '2007-07-25', '2007-07-26', '2007-07-27', '2007-07-30', '2007-07-31', '2007-08-01', '2007-08-02', '2007-08-03', '2007-08-06', '2007-08-07', '2007-08-08', '2007-08-09', '2007-08-10', '2007-08-13', '2007-08-14', '2007-08-15', '2007-08-16', '2007-08-17', '2007-08-20', '2007-08-21', '2007-08-22', '2007-08-23', '2007-08-24', '2007-08-27', '2007-08-28', '2007-08-29', '2007-08-30', '2007-08-31', '2007-09-03', '2007-09-04', '2007-09-05', '2007-09-06', '2007-09-07', '2007-09-10', '2007-09-11', '2007-09-12', '2007-09-13', '2007-09-14', '2007-09-17', '2007-09-18', '2007-09-19', '2007-09-20', '2007-09-21', '2007-09-24', '2007-09-25', '2007-09-26', '2007-09-27', '2007-09-28', '2007-10-08', '2007-10-09', '2007-10-10', '2007-10-11', '2007-10-12', '2007-10-15', '2007-10-16', '2007-10-17', '2007-10-18', '2007-10-19', '2007-10-22', '2007-10-23', '2007-10-24', '2007-10-25', '2007-10-26', '2007-10-29', '2007-10-30', '2007-10-31', '2007-11-01', '2007-11-02', '2007-11-05', '2007-11-06', '2007-11-07', '2007-11-08', '2007-11-09', '2007-11-12', '2007-11-13', '2007-11-14', '2007-11-15', '2007-11-16', '2007-11-19', '2007-11-20', '2007-11-21', '2007-11-22', '2007-11-23', '2007-11-26', '2007-11-27', '2007-11-28', '2007-11-29', '2007-11-30', '2007-12-03', '2007-12-04', '2007-12-05', '2007-12-06', '2007-12-07', '2007-12-10', '2007-12-11', '2007-12-12', '2007-12-13', '2007-12-14', '2007-12-17', '2007-12-18', '2007-12-19', '2007-12-20', '2007-12-21', '2007-12-24', '2007-12-25', '2007-12-26', '2007-12-27', '2007-12-28', '2008-01-02', '2008-01-03', '2008-01-04', '2008-01-07', '2008-01-08', '2008-01-09', '2008-01-10', '2008-01-11', '2008-01-14', '2008-01-15', '2008-01-16', '2008-01-17', '2008-01-18', '2008-01-21', '2008-01-22', '2008-01-23', '2008-01-24', '2008-01-25', '2008-01-28', '2008-01-29', '2008-01-30', '2008-01-31', '2008-02-01', '2008-02-04', '2008-02-05', '2008-02-13', '2008-02-14', '2008-02-15', '2008-02-18', '2008-02-19', '2008-02-20', '2008-02-21', '2008-02-22', '2008-02-25', '2008-02-26', '2008-02-27', '2008-02-28', '2008-02-29', '2008-03-03', '2008-03-04', '2008-03-05', '2008-03-06', '2008-03-07', '2008-03-10', '2008-03-11', '2008-03-12', '2008-03-13', '2008-03-14', '2008-03-17', '2008-03-18', '2008-03-19', '2008-03-20', '2008-03-21', '2008-03-24', '2008-03-25', '2008-03-26', '2008-03-27', '2008-03-28', '2008-03-31', '2008-04-01', '2008-04-02', '2008-04-03', '2008-04-07', '2008-04-08', '2008-04-09', '2008-04-10', '2008-04-11', '2008-04-14', '2008-04-15', '2008-04-16', '2008-04-17', '2008-04-18', '2008-04-21', '2008-04-22', '2008-04-23', '2008-04-24', '2008-04-25', '2008-04-28', '2008-04-29', '2008-04-30', '2008-05-05', '2008-05-06', '2008-05-07', '2008-05-08', '2008-05-09', '2008-05-12', '2008-05-13', '2008-05-14', '2008-05-15', '2008-05-16', '2008-05-19', '2008-05-20', '2008-05-21', '2008-05-22', '2008-05-23', '2008-05-26', '2008-05-27', '2008-05-28', '2008-05-29', '2008-05-30', '2008-06-02', '2008-06-03', '2008-06-04', '2008-06-05', '2008-06-06', '2008-06-10', '2008-06-11', '2008-06-12', '2008-06-13', '2008-06-16', '2008-06-17', '2008-06-18', '2008-06-19', '2008-06-20', '2008-06-23', '2008-06-24', '2008-06-25', '2008-06-26', '2008-06-27', '2008-06-30', '2008-07-01', '2008-07-02', '2008-07-03', '2008-07-04', '2008-07-07', '2008-07-08', '2008-07-09', '2008-07-10', '2008-07-11', '2008-07-14', '2008-07-15', '2008-07-16', '2008-07-17', '2008-07-18', '2008-07-21', '2008-07-22', '2008-07-23', '2008-07-24', '2008-07-25', '2008-07-28', '2008-07-29', '2008-07-30', '2008-07-31', '2008-08-01', '2008-08-04', '2008-08-05', '2008-08-06', '2008-08-07', '2008-08-08', '2008-08-11', '2008-08-12', '2008-08-13', '2008-08-14', '2008-08-15', '2008-08-18', '2008-08-19', '2008-08-20', '2008-08-21', '2008-08-22', '2008-08-25', '2008-08-26', '2008-08-27', '2008-08-28', '2008-08-29', '2008-09-01', '2008-09-02', '2008-09-03', '2008-09-04', '2008-09-05', '2008-09-08', '2008-09-09', '2008-09-10', '2008-09-11', '2008-09-12', '2008-09-16', '2008-09-17', '2008-09-18', '2008-09-19', '2008-09-22', '2008-09-23', '2008-09-24', '2008-09-25', '2008-09-26', '2008-10-06', '2008-10-07', '2008-10-08', '2008-10-09', '2008-10-10', '2008-10-13', '2008-10-14', '2008-10-15', '2008-10-16', '2008-10-17', '2008-10-20', '2008-10-21', '2008-10-22', '2008-10-23', '2008-10-24', '2008-10-27', '2008-10-28', '2008-10-29', '2008-10-30', '2008-10-31', '2008-11-03', '2008-11-04', '2008-11-05', '2008-11-06', '2008-11-07', '2008-11-10', '2008-11-11', '2008-11-12', '2008-11-13', '2008-11-14', '2008-11-17', '2008-11-18', '2008-11-19', '2008-11-20', '2008-11-21', '2008-11-24', '2008-11-25', '2008-11-26', '2008-11-27', '2008-11-28', '2008-12-01', '2008-12-02', '2008-12-03', '2008-12-04', '2008-12-05', '2008-12-08', '2008-12-09', '2008-12-10', '2008-12-11', '2008-12-12', '2008-12-15', '2008-12-16', '2008-12-17', '2008-12-18', '2008-12-19', '2008-12-22', '2008-12-23', '2008-12-24', '2008-12-25', '2008-12-26', '2008-12-29', '2008-12-30', '2008-12-31', '2009-01-05', '2009-01-06', '2009-01-07', '2009-01-08', '2009-01-09', '2009-01-12', '2009-01-13', '2009-01-14', '2009-01-15', '2009-01-16', '2009-01-19', '2009-01-20', '2009-01-21', '2009-01-22', '2009-01-23', '2009-02-02', '2009-02-03', '2009-02-04', '2009-02-05', '2009-02-06', '2009-02-09', '2009-02-10', '2009-02-11', '2009-02-12', '2009-02-13', '2009-02-16', '2009-02-17', '2009-02-18', '2009-02-19', '2009-02-20', '2009-02-23', '2009-02-24', '2009-02-25', '2009-02-26', '2009-02-27', '2009-03-02', '2009-03-03', '2009-03-04', '2009-03-05', '2009-03-06', '2009-03-09', '2009-03-10', '2009-03-11', '2009-03-12', '2009-03-13', '2009-03-16', '2009-03-17', '2009-03-18', '2009-03-19', '2009-03-20', '2009-03-23', '2009-03-24', '2009-03-25', '2009-03-26', '2009-03-27', '2009-03-30', '2009-03-31', '2009-04-01', '2009-04-02', '2009-04-03', '2009-04-07', '2009-04-08', '2009-04-09', '2009-04-10', '2009-04-13', '2009-04-14', '2009-04-15', '2009-04-16', '2009-04-17', '2009-04-20', '2009-04-21', '2009-04-22', '2009-04-23', '2009-04-24', '2009-04-27', '2009-04-28', '2009-04-29', '2009-04-30', '2009-05-04', '2009-05-05', '2009-05-06', '2009-05-07', '2009-05-08', '2009-05-11', '2009-05-12', '2009-05-13', '2009-05-14', '2009-05-15', '2009-05-18', '2009-05-19', '2009-05-20', '2009-05-21', '2009-05-22', '2009-05-25', '2009-05-26', '2009-05-27', '2009-06-01', '2009-06-02', '2009-06-03', '2009-06-04', '2009-06-05', '2009-06-08', '2009-06-09', '2009-06-10', '2009-06-11', '2009-06-12', '2009-06-15', '2009-06-16', '2009-06-17', '2009-06-18', '2009-06-19', '2009-06-22', '2009-06-23', '2009-06-24', '2009-06-25', '2009-06-26', '2009-06-29', '2009-06-30', '2009-07-01', '2009-07-02', '2009-07-03', '2009-07-06', '2009-07-07', '2009-07-08', '2009-07-09', '2009-07-10', '2009-07-13', '2009-07-14', '2009-07-15', '2009-07-16', '2009-07-17', '2009-07-20', '2009-07-21', '2009-07-22', '2009-07-23', '2009-07-24', '2009-07-27', '2009-07-28', '2009-07-29', '2009-07-30', '2009-07-31', '2009-08-03', '2009-08-04', '2009-08-05', '2009-08-06', '2009-08-07', '2009-08-10', '2009-08-11', '2009-08-12', '2009-08-13', '2009-08-14', '2009-08-17', '2009-08-18', '2009-08-19', '2009-08-20', '2009-08-21', '2009-08-24', '2009-08-25', '2009-08-26', '2009-08-27', '2009-08-28', '2009-08-31', '2009-09-01', '2009-09-02', '2009-09-03', '2009-09-04', '2009-09-07', '2009-09-08', '2009-09-09', '2009-09-10', '2009-09-11', '2009-09-14', '2009-09-15', '2009-09-16', '2009-09-17', '2009-09-18', '2009-09-21', '2009-09-22', '2009-09-23', '2009-09-24', '2009-09-25', '2009-09-28', '2009-09-29', '2009-09-30', '2009-10-09', '2009-10-12', '2009-10-13', '2009-10-14', '2009-10-15', '2009-10-16', '2009-10-19', '2009-10-20', '2009-10-21', '2009-10-22', '2009-10-23', '2009-10-26', '2009-10-27', '2009-10-28', '2009-10-29', '2009-10-30', '2009-11-02', '2009-11-03', '2009-11-04', '2009-11-05', '2009-11-06', '2009-11-09', '2009-11-10', '2009-11-11', '2009-11-12', '2009-11-13', '2009-11-16', '2009-11-17', '2009-11-18', '2009-11-19', '2009-11-20', '2009-11-23', '2009-11-24', '2009-11-25', '2009-11-26', '2009-11-27', '2009-11-30', '2009-12-01', '2009-12-02', '2009-12-03', '2009-12-04', '2009-12-07', '2009-12-08', '2009-12-09', '2009-12-10', '2009-12-11', '2009-12-14', '2009-12-15', '2009-12-16', '2009-12-17', '2009-12-18', '2009-12-21', '2009-12-22', '2009-12-23', '2009-12-24', '2009-12-25', '2009-12-28', '2009-12-29', '2009-12-30', '2009-12-31', '2010-01-04', '2010-01-05', '2010-01-06', '2010-01-07', '2010-01-08', '2010-01-11', '2010-01-12', '2010-01-13', '2010-01-14', '2010-01-15', '2010-01-18', '2010-01-19', '2010-01-20', '2010-01-21', '2010-01-22', '2010-01-25', '2010-01-26', '2010-01-27', '2010-01-28', '2010-01-29', '2010-02-01', '2010-02-02', '2010-02-03', '2010-02-04', '2010-02-05', '2010-02-08', '2010-02-09', '2010-02-10', '2010-02-11', '2010-02-12', '2010-02-22', '2010-02-23', '2010-02-24', '2010-02-25', '2010-02-26', '2010-03-01', '2010-03-02', '2010-03-03', '2010-03-04', '2010-03-05', '2010-03-08', '2010-03-09', '2010-03-10', '2010-03-11', '2010-03-12', '2010-03-15', '2010-03-16', '2010-03-17', '2010-03-18', '2010-03-19', '2010-03-22', '2010-03-23', '2010-03-24', '2010-03-25', '2010-03-26', '2010-03-29', '2010-03-30', '2010-03-31', '2010-04-01', '2010-04-02', '2010-04-06', '2010-04-07', '2010-04-08', '2010-04-09', '2010-04-12', '2010-04-13', '2010-04-14', '2010-04-15', '2010-04-16', '2010-04-19', '2010-04-20', '2010-04-21', '2010-04-22', '2010-04-23', '2010-04-26', '2010-04-27', '2010-04-28', '2010-04-29', '2010-04-30', '2010-05-04', '2010-05-05', '2010-05-06', '2010-05-07', '2010-05-10', '2010-05-11', '2010-05-12', '2010-05-13', '2010-05-14', '2010-05-17', '2010-05-18', '2010-05-19', '2010-05-20', '2010-05-21', '2010-05-24', '2010-05-25', '2010-05-26', '2010-05-27', '2010-05-28', '2010-05-31', '2010-06-01', '2010-06-02', '2010-06-03', '2010-06-04', '2010-06-07', '2010-06-08', '2010-06-09', '2010-06-10', '2010-06-11', '2010-06-17', '2010-06-18', '2010-06-21', '2010-06-22', '2010-06-23', '2010-06-24', '2010-06-25', '2010-06-28', '2010-06-29', '2010-06-30', '2010-07-01', '2010-07-02', '2010-07-05', '2010-07-06', '2010-07-07', '2010-07-08', '2010-07-09', '2010-07-12', '2010-07-13', '2010-07-14', '2010-07-15', '2010-07-16', '2010-07-19', '2010-07-20', '2010-07-21', '2010-07-22', '2010-07-23', '2010-07-26', '2010-07-27', '2010-07-28', '2010-07-29', '2010-07-30', '2010-08-02', '2010-08-03', '2010-08-04', '2010-08-05', '2010-08-06', '2010-08-09', '2010-08-10', '2010-08-11', '2010-08-12', '2010-08-13', '2010-08-16', '2010-08-17', '2010-08-18', '2010-08-19', '2010-08-20', '2010-08-23', '2010-08-24', '2010-08-25', '2010-08-26', '2010-08-27', '2010-08-30', '2010-08-31', '2010-09-01', '2010-09-02', '2010-09-03', '2010-09-06', '2010-09-07', '2010-09-08', '2010-09-09', '2010-09-10', '2010-09-13', '2010-09-14', '2010-09-15', '2010-09-16', '2010-09-17', '2010-09-20', '2010-09-21', '2010-09-27', '2010-09-28', '2010-09-29', '2010-09-30', '2010-10-08', '2010-10-11', '2010-10-12', '2010-10-13', '2010-10-14', '2010-10-15', '2010-10-18', '2010-10-19', '2010-10-20', '2010-10-21', '2010-10-22', '2010-10-25', '2010-10-26', '2010-10-27', '2010-10-28', '2010-10-29', '2010-11-01', '2010-11-02', '2010-11-03', '2010-11-04', '2010-11-05', '2010-11-08', '2010-11-09', '2010-11-10', '2010-11-11', '2010-11-12', '2010-11-15', '2010-11-16', '2010-11-17', '2010-11-18', '2010-11-19', '2010-11-22', '2010-11-23', '2010-11-24', '2010-11-25', '2010-11-26', '2010-11-29', '2010-11-30', '2010-12-01', '2010-12-02', '2010-12-03', '2010-12-06', '2010-12-07', '2010-12-08', '2010-12-09', '2010-12-10', '2010-12-13', '2010-12-14', '2010-12-15', '2010-12-16', '2010-12-17', '2010-12-20', '2010-12-21', '2010-12-22', '2010-12-23', '2010-12-24', '2010-12-27', '2010-12-28', '2010-12-29', '2010-12-30', '2010-12-31', '2011-01-04', '2011-01-05', '2011-01-06', '2011-01-07', '2011-01-10', '2011-01-11', '2011-01-12', '2011-01-13', '2011-01-14', '2011-01-17', '2011-01-18', '2011-01-19', '2011-01-20', '2011-01-21', '2011-01-24', '2011-01-25', '2011-01-26', '2011-01-27', '2011-01-28', '2011-01-31', '2011-02-01', '2011-02-09', '2011-02-10', '2011-02-11', '2011-02-14', '2011-02-15', '2011-02-16', '2011-02-17', '2011-02-18', '2011-02-21', '2011-02-22', '2011-02-23', '2011-02-24', '2011-02-25', '2011-02-28', '2011-03-01', '2011-03-02', '2011-03-03', '2011-03-04', '2011-03-07', '2011-03-08', '2011-03-09', '2011-03-10', '2011-03-11', '2011-03-14', '2011-03-15', '2011-03-16', '2011-03-17', '2011-03-18', '2011-03-21', '2011-03-22', '2011-03-23', '2011-03-24', '2011-03-25', '2011-03-28', '2011-03-29', '2011-03-30', '2011-03-31', '2011-04-01', '2011-04-06', '2011-04-07', '2011-04-08', '2011-04-11', '2011-04-12', '2011-04-13', '2011-04-14', '2011-04-15', '2011-04-18', '2011-04-19', '2011-04-20', '2011-04-21', '2011-04-22', '2011-04-25', '2011-04-26', '2011-04-27', '2011-04-28', '2011-04-29', '2011-05-03', '2011-05-04', '2011-05-05', '2011-05-06', '2011-05-09', '2011-05-10', '2011-05-11', '2011-05-12', '2011-05-13', '2011-05-16', '2011-05-17', '2011-05-18', '2011-05-19', '2011-05-20', '2011-05-23', '2011-05-24', '2011-05-25', '2011-05-26', '2011-05-27', '2011-05-30', '2011-05-31', '2011-06-01', '2011-06-02', '2011-06-03', '2011-06-07', '2011-06-08', '2011-06-09', '2011-06-10', '2011-06-13', '2011-06-14', '2011-06-15', '2011-06-16', '2011-06-17', '2011-06-20', '2011-06-21', '2011-06-22', '2011-06-23', '2011-06-24', '2011-06-27', '2011-06-28', '2011-06-29', '2011-06-30', '2011-07-01', '2011-07-04', '2011-07-05', '2011-07-06', '2011-07-07', '2011-07-08', '2011-07-11', '2011-07-12', '2011-07-13', '2011-07-14', '2011-07-15', '2011-07-18', '2011-07-19', '2011-07-20', '2011-07-21', '2011-07-22', '2011-07-25', '2011-07-26', '2011-07-27', '2011-07-28', '2011-07-29', '2011-08-01', '2011-08-02', '2011-08-03', '2011-08-04', '2011-08-05', '2011-08-08', '2011-08-09', '2011-08-10', '2011-08-11', '2011-08-12', '2011-08-15', '2011-08-16', '2011-08-17', '2011-08-18', '2011-08-19', '2011-08-22', '2011-08-23', '2011-08-24', '2011-08-25', '2011-08-26', '2011-08-29', '2011-08-30', '2011-08-31', '2011-09-01', '2011-09-02', '2011-09-05', '2011-09-06', '2011-09-07', '2011-09-08', '2011-09-09', '2011-09-13', '2011-09-14', '2011-09-15', '2011-09-16', '2011-09-19', '2011-09-20', '2011-09-21', '2011-09-22', '2011-09-23', '2011-09-26', '2011-09-27', '2011-09-28', '2011-09-29', '2011-09-30', '2011-10-10', '2011-10-11', '2011-10-12', '2011-10-13', '2011-10-14', '2011-10-17', '2011-10-18', '2011-10-19', '2011-10-20', '2011-10-21', '2011-10-24', '2011-10-25', '2011-10-26', '2011-10-27', '2011-10-28', '2011-10-31', '2011-11-01', '2011-11-02', '2011-11-03', '2011-11-04', '2011-11-07', '2011-11-08', '2011-11-09', '2011-11-10', '2011-11-11', '2011-11-14', '2011-11-15', '2011-11-16', '2011-11-17', '2011-11-18', '2011-11-21', '2011-11-22', '2011-11-23', '2011-11-24', '2011-11-25', '2011-11-28', '2011-11-29', '2011-11-30', '2011-12-01', '2011-12-02', '2011-12-05', '2011-12-06', '2011-12-07', '2011-12-08', '2011-12-09', '2011-12-12', '2011-12-13', '2011-12-14', '2011-12-15', '2011-12-16', '2011-12-19', '2011-12-20', '2011-12-21', '2011-12-22', '2011-12-23', '2011-12-26', '2011-12-27', '2011-12-28', '2011-12-29', '2011-12-30', '2012-01-04', '2012-01-05', '2012-01-06', '2012-01-09', '2012-01-10', '2012-01-11', '2012-01-12', '2012-01-13', '2012-01-16', '2012-01-17', '2012-01-18', '2012-01-19', '2012-01-20', '2012-01-30', '2012-01-31', '2012-02-01', '2012-02-02', '2012-02-03', '2012-02-06', '2012-02-07', '2012-02-08', '2012-02-09', '2012-02-10', '2012-02-13', '2012-02-14', '2012-02-15', '2012-02-16', '2012-02-17', '2012-02-20', '2012-02-21', '2012-02-22', '2012-02-23', '2012-02-24', '2012-02-27', '2012-02-28', '2012-02-29', '2012-03-01', '2012-03-02', '2012-03-05', '2012-03-06', '2012-03-07', '2012-03-08', '2012-03-09', '2012-03-12', '2012-03-13', '2012-03-14', '2012-03-15', '2012-03-16', '2012-03-19', '2012-03-20', '2012-03-21', '2012-03-22', '2012-03-23', '2012-03-26', '2012-03-27', '2012-03-28', '2012-03-29', '2012-03-30', '2012-04-05', '2012-04-06', '2012-04-09', '2012-04-10', '2012-04-11', '2012-04-12', '2012-04-13', '2012-04-16', '2012-04-17', '2012-04-18', '2012-04-19', '2012-04-20', '2012-04-23', '2012-04-24', '2012-04-25', '2012-04-26', '2012-04-27', '2012-05-02', '2012-05-03', '2012-05-04', '2012-05-07', '2012-05-08', '2012-05-09', '2012-05-10', '2012-05-11', '2012-05-14', '2012-05-15', '2012-05-16', '2012-05-17', '2012-05-18', '2012-05-21', '2012-05-22', '2012-05-23', '2012-05-24', '2012-05-25', '2012-05-28', '2012-05-29', '2012-05-30', '2012-05-31', '2012-06-01', '2012-06-04', '2012-06-05', '2012-06-06', '2012-06-07', '2012-06-08', '2012-06-11', '2012-06-12', '2012-06-13', '2012-06-14', '2012-06-15', '2012-06-18', '2012-06-19', '2012-06-20', '2012-06-21', '2012-06-25', '2012-06-26', '2012-06-27', '2012-06-28', '2012-06-29', '2012-07-02', '2012-07-03', '2012-07-04', '2012-07-05', '2012-07-06', '2012-07-09', '2012-07-10', '2012-07-11', '2012-07-12', '2012-07-13', '2012-07-16', '2012-07-17', '2012-07-18', '2012-07-19', '2012-07-20', '2012-07-23', '2012-07-24', '2012-07-25', '2012-07-26', '2012-07-27', '2012-07-30', '2012-07-31', '2012-08-01', '2012-08-02', '2012-08-03', '2012-08-06', '2012-08-07', '2012-08-08', '2012-08-09', '2012-08-10', '2012-08-13', '2012-08-14', '2012-08-15', '2012-08-16', '2012-08-17', '2012-08-20', '2012-08-21', '2012-08-22', '2012-08-23', '2012-08-24', '2012-08-27', '2012-08-28', '2012-08-29', '2012-08-30', '2012-08-31', '2012-09-03', '2012-09-04', '2012-09-05', '2012-09-06', '2012-09-07', '2012-09-10', '2012-09-11', '2012-09-12', '2012-09-13', '2012-09-14', '2012-09-17', '2012-09-18', '2012-09-19', '2012-09-20', '2012-09-21', '2012-09-24', '2012-09-25', '2012-09-26', '2012-09-27', '2012-09-28', '2012-10-08', '2012-10-09', '2012-10-10', '2012-10-11', '2012-10-12', '2012-10-15', '2012-10-16', '2012-10-17', '2012-10-18', '2012-10-19', '2012-10-22', '2012-10-23', '2012-10-24', '2012-10-25', '2012-10-26', '2012-10-29', '2012-10-30', '2012-10-31', '2012-11-01', '2012-11-02', '2012-11-05', '2012-11-06', '2012-11-07', '2012-11-08', '2012-11-09', '2012-11-12', '2012-11-13', '2012-11-14', '2012-11-15', '2012-11-16', '2012-11-19', '2012-11-20', '2012-11-21', '2012-11-22', '2012-11-23', '2012-11-26', '2012-11-27', '2012-11-28', '2012-11-29', '2012-11-30', '2012-12-03', '2012-12-04', '2012-12-05', '2012-12-06', '2012-12-07', '2012-12-10', '2012-12-11', '2012-12-12', '2012-12-13', '2012-12-14', '2012-12-17', '2012-12-18', '2012-12-19', '2012-12-20', '2012-12-21', '2012-12-24', '2012-12-25', '2012-12-26', '2012-12-27', '2012-12-28', '2012-12-31', '2013-01-04', '2013-01-07', '2013-01-08', '2013-01-09', '2013-01-10', '2013-01-11', '2013-01-14', '2013-01-15', '2013-01-16', '2013-01-17', '2013-01-18', '2013-01-21', '2013-01-22', '2013-01-23', '2013-01-24', '2013-01-25', '2013-01-28', '2013-01-29', '2013-01-30', '2013-01-31', '2013-02-01', '2013-02-04', '2013-02-05', '2013-02-06', '2013-02-07', '2013-02-08', '2013-02-18', '2013-02-19', '2013-02-20', '2013-02-21', '2013-02-22', '2013-02-25', '2013-02-26', '2013-02-27', '2013-02-28', '2013-03-01', '2013-03-04', '2013-03-05', '2013-03-06', '2013-03-07', '2013-03-08', '2013-03-11', '2013-03-12', '2013-03-13', '2013-03-14', '2013-03-15', '2013-03-18', '2013-03-19', '2013-03-20', '2013-03-21', '2013-03-22', '2013-03-25', '2013-03-26', '2013-03-27', '2013-03-28', '2013-03-29', '2013-04-01', '2013-04-02', '2013-04-03', '2013-04-08', '2013-04-09', '2013-04-10', '2013-04-11', '2013-04-12', '2013-04-15', '2013-04-16', '2013-04-17', '2013-04-18', '2013-04-19', '2013-04-22', '2013-04-23', '2013-04-24', '2013-04-25', '2013-04-26', '2013-05-02', '2013-05-03', '2013-05-06', '2013-05-07', '2013-05-08', '2013-05-09', '2013-05-10', '2013-05-13', '2013-05-14', '2013-05-15', '2013-05-16', '2013-05-17', '2013-05-20', '2013-05-21', '2013-05-22', '2013-05-23', '2013-05-24', '2013-05-27', '2013-05-28', '2013-05-29', '2013-05-30', '2013-05-31', '2013-06-03', '2013-06-04', '2013-06-05', '2013-06-06', '2013-06-07', '2013-06-13', '2013-06-14', '2013-06-17', '2013-06-18', '2013-06-19', '2013-06-20', '2013-06-21', '2013-06-24', '2013-06-25', '2013-06-26', '2013-06-27', '2013-06-28', '2013-07-01', '2013-07-02', '2013-07-03', '2013-07-04', '2013-07-05', '2013-07-08', '2013-07-09', '2013-07-10', '2013-07-11', '2013-07-12', '2013-07-15', '2013-07-16', '2013-07-17', '2013-07-18', '2013-07-19', '2013-07-22', '2013-07-23', '2013-07-24', '2013-07-25', '2013-07-26', '2013-07-29', '2013-07-30', '2013-07-31', '2013-08-01', '2013-08-02', '2013-08-05', '2013-08-06', '2013-08-07', '2013-08-08', '2013-08-09', '2013-08-12', '2013-08-13', '2013-08-14', '2013-08-15', '2013-08-16', '2013-08-19', '2013-08-20', '2013-08-21', '2013-08-22', '2013-08-23', '2013-08-26', '2013-08-27', '2013-08-28', '2013-08-29', '2013-08-30', '2013-09-02', '2013-09-03', '2013-09-04', '2013-09-05', '2013-09-06', '2013-09-09', '2013-09-10', '2013-09-11', '2013-09-12', '2013-09-13', '2013-09-16', '2013-09-17', '2013-09-18', '2013-09-23', '2013-09-24', '2013-09-25', '2013-09-26', '2013-09-27', '2013-09-30', '2013-10-08', '2013-10-09', '2013-10-10', '2013-10-11', '2013-10-14', '2013-10-15', '2013-10-16', '2013-10-17', '2013-10-18', '2013-10-21', '2013-10-22', '2013-10-23', '2013-10-24', '2013-10-25', '2013-10-28', '2013-10-29', '2013-10-30', '2013-10-31', '2013-11-01', '2013-11-04', '2013-11-05', '2013-11-06', '2013-11-07', '2013-11-08', '2013-11-11', '2013-11-12', '2013-11-13', '2013-11-14', '2013-11-15', '2013-11-18', '2013-11-19', '2013-11-20', '2013-11-21', '2013-11-22', '2013-11-25', '2013-11-26', '2013-11-27', '2013-11-28', '2013-11-29', '2013-12-02', '2013-12-03', '2013-12-04', '2013-12-05', '2013-12-06', '2013-12-09', '2013-12-10', '2013-12-11', '2013-12-12', '2013-12-13', '2013-12-16', '2013-12-17', '2013-12-18', '2013-12-19', '2013-12-20', '2013-12-23', '2013-12-24', '2013-12-25', '2013-12-26', '2013-12-27', '2013-12-30', '2013-12-31', '2014-01-02', '2014-01-03', '2014-01-06', '2014-01-07', '2014-01-08', '2014-01-09', '2014-01-10', '2014-01-13', '2014-01-14', '2014-01-15', '2014-01-16', '2014-01-17', '2014-01-20', '2014-01-21', '2014-01-22', '2014-01-23', '2014-01-24', '2014-01-27', '2014-01-28', '2014-01-29', '2014-01-30', '2014-02-07', '2014-02-10', '2014-02-11', '2014-02-12', '2014-02-13', '2014-02-14', '2014-02-17', '2014-02-18', '2014-02-19', '2014-02-20', '2014-02-21', '2014-02-24', '2014-02-25', '2014-02-26', '2014-02-27', '2014-02-28', '2014-03-03', '2014-03-04', '2014-03-05', '2014-03-06', '2014-03-07', '2014-03-10', '2014-03-11', '2014-03-12', '2014-03-13', '2014-03-14', '2014-03-17', '2014-03-18', '2014-03-19', '2014-03-20', '2014-03-21', '2014-03-24', '2014-03-25', '2014-03-26', '2014-03-27', '2014-03-28', '2014-03-31', '2014-04-01', '2014-04-02', '2014-04-03', '2014-04-04', '2014-04-08', '2014-04-09', '2014-04-10', '2014-04-11', '2014-04-14', '2014-04-15', '2014-04-16', '2014-04-17', '2014-04-18', '2014-04-21', '2014-04-22', '2014-04-23', '2014-04-24', '2014-04-25', '2014-04-28', '2014-04-29', '2014-04-30', '2014-05-05', '2014-05-06', '2014-05-07', '2014-05-08', '2014-05-09', '2014-05-12', '2014-05-13', '2014-05-14', '2014-05-15', '2014-05-16', '2014-05-19', '2014-05-20', '2014-05-21', '2014-05-22', '2014-05-23', '2014-05-26', '2014-05-27', '2014-05-28', '2014-05-29', '2014-05-30', '2014-06-03', '2014-06-04', '2014-06-05', '2014-06-06', '2014-06-09', '2014-06-10', '2014-06-11', '2014-06-12', '2014-06-13', '2014-06-16', '2014-06-17', '2014-06-18', '2014-06-19', '2014-06-20', '2014-06-23', '2014-06-24', '2014-06-25', '2014-06-26', '2014-06-27', '2014-06-30', '2014-07-01', '2014-07-02', '2014-07-03', '2014-07-04', '2014-07-07', '2014-07-08', '2014-07-09', '2014-07-10', '2014-07-11', '2014-07-14', '2014-07-15', '2014-07-16', '2014-07-17', '2014-07-18', '2014-07-21', '2014-07-22', '2014-07-23', '2014-07-24', '2014-07-25', '2014-07-28', '2014-07-29', '2014-07-30', '2014-07-31', '2014-08-01', '2014-08-04', '2014-08-05', '2014-08-06', '2014-08-07', '2014-08-08', '2014-08-11', '2014-08-12', '2014-08-13', '2014-08-14', '2014-08-15', '2014-08-18', '2014-08-19', '2014-08-20', '2014-08-21', '2014-08-22', '2014-08-25', '2014-08-26', '2014-08-27', '2014-08-28', '2014-08-29', '2014-09-01', '2014-09-02', '2014-09-03', '2014-09-04', '2014-09-05', '2014-09-09', '2014-09-10', '2014-09-11', '2014-09-12', '2014-09-15', '2014-09-16', '2014-09-17', '2014-09-18', '2014-09-19', '2014-09-22', '2014-09-23', '2014-09-24', '2014-09-25', '2014-09-26', '2014-09-29', '2014-09-30', '2014-10-08', '2014-10-09', '2014-10-10', '2014-10-13', '2014-10-14', '2014-10-15', '2014-10-16', '2014-10-17', '2014-10-20', '2014-10-21', '2014-10-22', '2014-10-23', '2014-10-24', '2014-10-27', '2014-10-28', '2014-10-29', '2014-10-30', '2014-10-31', '2014-11-03', '2014-11-04', '2014-11-05', '2014-11-06', '2014-11-07', '2014-11-10', '2014-11-11', '2014-11-12', '2014-11-13', '2014-11-14', '2014-11-17', '2014-11-18', '2014-11-19', '2014-11-20', '2014-11-21', '2014-11-24', '2014-11-25', '2014-11-26', '2014-11-27', '2014-11-28', '2014-12-01', '2014-12-02', '2014-12-03', '2014-12-04', '2014-12-05', '2014-12-08', '2014-12-09', '2014-12-10', '2014-12-11', '2014-12-12', '2014-12-15', '2014-12-16', '2014-12-17', '2014-12-18', '2014-12-19', '2014-12-22', '2014-12-23', '2014-12-24', '2014-12-25', '2014-12-26', '2014-12-29', '2014-12-30', '2014-12-31', '2015-01-05', '2015-01-06', '2015-01-07', '2015-01-08', '2015-01-09', '2015-01-12', '2015-01-13', '2015-01-14', '2015-01-15', '2015-01-16', '2015-01-19', '2015-01-20', '2015-01-21', '2015-01-22', '2015-01-23', '2015-01-26', '2015-01-27', '2015-01-28', '2015-01-29', '2015-01-30', '2015-02-02', '2015-02-03', '2015-02-04', '2015-02-05', '2015-02-06', '2015-02-09', '2015-02-10', '2015-02-11', '2015-02-12', '2015-02-13', '2015-02-16', '2015-02-17', '2015-02-25', '2015-02-26', '2015-02-27', '2015-03-02', '2015-03-03', '2015-03-04', '2015-03-05', '2015-03-06', '2015-03-09', '2015-03-10', '2015-03-11', '2015-03-12', '2015-03-13', '2015-03-16', '2015-03-17', '2015-03-18', '2015-03-19', '2015-03-20', '2015-03-23', '2015-03-24', '2015-03-25', '2015-03-26', '2015-03-27', '2015-03-30', '2015-03-31', '2015-04-01', '2015-04-02', '2015-04-03', '2015-04-07', '2015-04-08', '2015-04-09', '2015-04-10', '2015-04-13', '2015-04-14', '2015-04-15', '2015-04-16', '2015-04-17', '2015-04-20', '2015-04-21', '2015-04-22', '2015-04-23', '2015-04-24', '2015-04-27', '2015-04-28', '2015-04-29', '2015-04-30', '2015-05-04', '2015-05-05', '2015-05-06', '2015-05-07', '2015-05-08', '2015-05-11', '2015-05-12', '2015-05-13', '2015-05-14', '2015-05-15', '2015-05-18', '2015-05-19', '2015-05-20', '2015-05-21', '2015-05-22', '2015-05-25', '2015-05-26', '2015-05-27', '2015-05-28', '2015-05-29', '2015-06-01', '2015-06-02', '2015-06-03', '2015-06-04', '2015-06-05', '2015-06-08', '2015-06-09', '2015-06-10', '2015-06-11', '2015-06-12', '2015-06-15', '2015-06-16', '2015-06-17', '2015-06-18', '2015-06-19', '2015-06-23', '2015-06-24', '2015-06-25', '2015-06-26', '2015-06-29', '2015-06-30', '2015-07-01', '2015-07-02', '2015-07-03', '2015-07-06', '2015-07-07', '2015-07-08', '2015-07-09', '2015-07-10', '2015-07-13', '2015-07-14', '2015-07-15', '2015-07-16', '2015-07-17', '2015-07-20', '2015-07-21', '2015-07-22', '2015-07-23', '2015-07-24', '2015-07-27', '2015-07-28', '2015-07-29', '2015-07-30', '2015-07-31', '2015-08-03', '2015-08-04', '2015-08-05', '2015-08-06', '2015-08-07', '2015-08-10', '2015-08-11', '2015-08-12', '2015-08-13', '2015-08-14', '2015-08-17', '2015-08-18', '2015-08-19', '2015-08-20', '2015-08-21', '2015-08-24', '2015-08-25', '2015-08-26', '2015-08-27', '2015-08-28', '2015-08-31', '2015-09-01', '2015-09-02', '2015-09-07', '2015-09-08', '2015-09-09', '2015-09-10', '2015-09-11', '2015-09-14', '2015-09-15', '2015-09-16', '2015-09-17', '2015-09-18', '2015-09-21', '2015-09-22', '2015-09-23', '2015-09-24', '2015-09-25', '2015-09-28', '2015-09-29', '2015-09-30', '2015-10-08', '2015-10-09', '2015-10-12', '2015-10-13', '2015-10-14', '2015-10-15', '2015-10-16', '2015-10-19', '2015-10-20', '2015-10-21', '2015-10-22', '2015-10-23', '2015-10-26', '2015-10-27', '2015-10-28', '2015-10-29', '2015-10-30', '2015-11-02', '2015-11-03', '2015-11-04', '2015-11-05', '2015-11-06', '2015-11-09', '2015-11-10', '2015-11-11', '2015-11-12', '2015-11-13', '2015-11-16', '2015-11-17', '2015-11-18', '2015-11-19', '2015-11-20', '2015-11-23', '2015-11-24', '2015-11-25', '2015-11-26', '2015-11-27', '2015-11-30', '2015-12-01', '2015-12-02', '2015-12-03', '2015-12-04', '2015-12-07', '2015-12-08', '2015-12-09', '2015-12-10', '2015-12-11', '2015-12-14', '2015-12-15', '2015-12-16', '2015-12-17', '2015-12-18', '2015-12-21', '2015-12-22', '2015-12-23', '2015-12-24', '2015-12-25', '2015-12-28', '2015-12-29', '2015-12-30', '2015-12-31', '2016-01-04', '2016-01-05', '2016-01-06', '2016-01-07', '2016-01-08', '2016-01-11', '2016-01-12', '2016-01-13', '2016-01-14', '2016-01-15', '2016-01-18', '2016-01-19', '2016-01-20', '2016-01-21', '2016-01-22', '2016-01-25', '2016-01-26', '2016-01-27', '2016-01-28', '2016-01-29', '2016-02-01', '2016-02-02', '2016-02-03', '2016-02-04', '2016-02-05', '2016-02-15', '2016-02-16', '2016-02-17', '2016-02-18', '2016-02-19', '2016-02-22', '2016-02-23', '2016-02-24', '2016-02-25', '2016-02-26', '2016-02-29', '2016-03-01', '2016-03-02', '2016-03-03', '2016-03-04', '2016-03-07', '2016-03-08', '2016-03-09', '2016-03-10', '2016-03-11', '2016-03-14', '2016-03-15', '2016-03-16', '2016-03-17', '2016-03-18', '2016-03-21', '2016-03-22', '2016-03-23', '2016-03-24', '2016-03-25', '2016-03-28', '2016-03-29', '2016-03-30', '2016-03-31', '2016-04-01', '2016-04-05', '2016-04-06', '2016-04-07', '2016-04-08', '2016-04-11', '2016-04-12', '2016-04-13', '2016-04-14', '2016-04-15', '2016-04-18', '2016-04-19', '2016-04-20', '2016-04-21', '2016-04-22', '2016-04-25', '2016-04-26', '2016-04-27', '2016-04-28', '2016-04-29', '2016-05-03', '2016-05-04', '2016-05-05', '2016-05-06', '2016-05-09', '2016-05-10', '2016-05-11', '2016-05-12', '2016-05-13', '2016-05-16', '2016-05-17', '2016-05-18', '2016-05-19', '2016-05-20', '2016-05-23', '2016-05-24', '2016-05-25', '2016-05-26', '2016-05-27', '2016-05-30', '2016-05-31', '2016-06-01', '2016-06-02', '2016-06-03', '2016-06-06', '2016-06-07', '2016-06-08', '2016-06-13', '2016-06-14', '2016-06-15', '2016-06-16', '2016-06-17', '2016-06-20', '2016-06-21', '2016-06-22', '2016-06-23', '2016-06-24', '2016-06-27', '2016-06-28', '2016-06-29', '2016-06-30', '2016-07-01', '2016-07-04', '2016-07-05', '2016-07-06', '2016-07-07', '2016-07-08', '2016-07-11', '2016-07-12', '2016-07-13', '2016-07-14', '2016-07-15', '2016-07-18', '2016-07-19', '2016-07-20', '2016-07-21', '2016-07-22', '2016-07-25', '2016-07-26', '2016-07-27', '2016-07-28', '2016-07-29', '2016-08-01', '2016-08-02', '2016-08-03', '2016-08-04', '2016-08-05', '2016-08-08', '2016-08-09', '2016-08-10', '2016-08-11', '2016-08-12', '2016-08-15', '2016-08-16', '2016-08-17', '2016-08-18', '2016-08-19', '2016-08-22', '2016-08-23', '2016-08-24', '2016-08-25', '2016-08-26', '2016-08-29', '2016-08-30', '2016-08-31', '2016-09-01', '2016-09-02', '2016-09-05', '2016-09-06', '2016-09-07', '2016-09-08', '2016-09-09', '2016-09-12', '2016-09-13', '2016-09-14', '2016-09-19', '2016-09-20', '2016-09-21', '2016-09-22', '2016-09-23', '2016-09-26', '2016-09-27', '2016-09-28', '2016-09-29', '2016-09-30', '2016-10-10', '2016-10-11', '2016-10-12', '2016-10-13', '2016-10-14', '2016-10-17', '2016-10-18', '2016-10-19', '2016-10-20', '2016-10-21', '2016-10-24', '2016-10-25', '2016-10-26', '2016-10-27', '2016-10-28', '2016-10-31', '2016-11-01', '2016-11-02', '2016-11-03', '2016-11-04', '2016-11-07', '2016-11-08', '2016-11-09', '2016-11-10', '2016-11-11', '2016-11-14', '2016-11-15', '2016-11-16', '2016-11-17', '2016-11-18', '2016-11-21', '2016-11-22', '2016-11-23', '2016-11-24', '2016-11-25', '2016-11-28', '2016-11-29', '2016-11-30', '2016-12-01', '2016-12-02', '2016-12-05', '2016-12-06', '2016-12-07', '2016-12-08', '2016-12-09', '2016-12-12', '2016-12-13', '2016-12-14', '2016-12-15', '2016-12-16', '2016-12-19', '2016-12-20', '2016-12-21', '2016-12-22', '2016-12-23', '2016-12-26', '2016-12-27', '2016-12-28', '2016-12-29', '2016-12-30', '2017-01-03', '2017-01-04', '2017-01-05', '2017-01-06', '2017-01-09', '2017-01-10', '2017-01-11', '2017-01-12', '2017-01-13', '2017-01-16', '2017-01-17', '2017-01-18', '2017-01-19', '2017-01-20', '2017-01-23', '2017-01-24', '2017-01-25', '2017-01-26', '2017-02-03', '2017-02-06', '2017-02-07', '2017-02-08', '2017-02-09', '2017-02-10', '2017-02-13', '2017-02-14', '2017-02-15', '2017-02-16', '2017-02-17', '2017-02-20', '2017-02-21', '2017-02-22', '2017-02-23', '2017-02-24', '2017-02-27', '2017-02-28', '2017-03-01', '2017-03-02', '2017-03-03', '2017-03-06', '2017-03-07', '2017-03-08', '2017-03-09', '2017-03-10', '2017-03-13', '2017-03-14', '2017-03-15', '2017-03-16', '2017-03-17', '2017-03-20', '2017-03-21', '2017-03-22', '2017-03-23', '2017-03-24', '2017-03-27', '2017-03-28', '2017-03-29', '2017-03-30', '2017-03-31', '2017-04-05', '2017-04-06', '2017-04-07', '2017-04-10', '2017-04-11', '2017-04-12', '2017-04-13', '2017-04-14', '2017-04-17', '2017-04-18', '2017-04-19', '2017-04-20', '2017-04-21', '2017-04-24', '2017-04-25', '2017-04-26', '2017-04-27', '2017-04-28', '2017-05-02', '2017-05-03', '2017-05-04', '2017-05-05', '2017-05-08', '2017-05-09', '2017-05-10', '2017-05-11', '2017-05-12', '2017-05-15', '2017-05-16', '2017-05-17', '2017-05-18', '2017-05-19', '2017-05-22', '2017-05-23', '2017-05-24', '2017-05-25', '2017-05-26', '2017-05-31', '2017-06-01', '2017-06-02', '2017-06-05', '2017-06-06', '2017-06-07', '2017-06-08', '2017-06-09', '2017-06-12', '2017-06-13', '2017-06-14', '2017-06-15', '2017-06-16', '2017-06-19', '2017-06-20', '2017-06-21', '2017-06-22', '2017-06-23', '2017-06-26', '2017-06-27', '2017-06-28', '2017-06-29', '2017-06-30', '2017-07-03', '2017-07-04', '2017-07-05', '2017-07-06', '2017-07-07', '2017-07-10', '2017-07-11', '2017-07-12', '2017-07-13', '2017-07-14', '2017-07-17', '2017-07-18', '2017-07-19', '2017-07-20', '2017-07-21', '2017-07-24', '2017-07-25', '2017-07-26', '2017-07-27', '2017-07-28', '2017-07-31', '2017-08-01', '2017-08-02', '2017-08-03', '2017-08-04', '2017-08-07', '2017-08-08', '2017-08-09', '2017-08-10', '2017-08-11', '2017-08-14', '2017-08-15', '2017-08-16', '2017-08-17', '2017-08-18', '2017-08-21', '2017-08-22', '2017-08-23', '2017-08-24', '2017-08-25', '2017-08-28', '2017-08-29', '2017-08-30', '2017-08-31', '2017-09-01', '2017-09-04', '2017-09-05', '2017-09-06', '2017-09-07', '2017-09-08', '2017-09-11', '2017-09-12', '2017-09-13', '2017-09-14', '2017-09-15', '2017-09-18', '2017-09-19', '2017-09-20', '2017-09-21', '2017-09-22', '2017-09-25', '2017-09-26', '2017-09-27', '2017-09-28', '2017-09-29', '2017-10-09', '2017-10-10', '2017-10-11', '2017-10-12', '2017-10-13', '2017-10-16', '2017-10-17', '2017-10-18', '2017-10-19', '2017-10-20', '2017-10-23', '2017-10-24', '2017-10-25', '2017-10-26', '2017-10-27', '2017-10-30', '2017-10-31', '2017-11-01', '2017-11-02', '2017-11-03', '2017-11-06', '2017-11-07', '2017-11-08', '2017-11-09', '2017-11-10', '2017-11-13', '2017-11-14', '2017-11-15', '2017-11-16', '2017-11-17', '2017-11-20', '2017-11-21', '2017-11-22', '2017-11-23', '2017-11-24', '2017-11-27', '2017-11-28', '2017-11-29', '2017-11-30', '2017-12-01', '2017-12-04', '2017-12-05', '2017-12-06', '2017-12-07', '2017-12-08', '2017-12-11', '2017-12-12', '2017-12-13', '2017-12-14', '2017-12-15', '2017-12-18', '2017-12-19', '2017-12-20', '2017-12-21', '2017-12-22', '2017-12-25', '2017-12-26', '2017-12-27', '2017-12-28']